package cnv.hf.widgets;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.drawable.Drawable;

public class HFDialogMessage {
	
	private final static String MSGBOX_BTN_CAPTION_OK		=	"ȷ";
	private final static String MSGBOX_BTN_CAPTION_CANCEL	=	"ȡ";
	private final static String MSGBOX_BTN_CAPTION_ABORT	=	"ֹ";
	private final static String MSGBOX_BTN_CAPTION_RETRY	=	"";
	private final static String MSGBOX_BTN_CAPTION_IGNORE	=	"";
	private final static String MSGBOX_BTN_CAPTION_YES		=	"";
	private final static String MSGBOX_BTN_CAPTION_NO		=	"";
	
    private static AlertDialog.Builder builder = null;  
    private static Object synObj = new Object();  
  
    public static void showDialog(	final Context context,
    								final Drawable icon,
    								final String title, 
    								final String message,
    								final int eType, 
    								final DialogInterface.OnClickListener positiveListener,
    								final DialogInterface.OnClickListener negativeListener,
    								final DialogInterface.OnClickListener neutralListener
    								) {  
    	
    	Activity act = (Activity) context;
    	act.runOnUiThread(new Runnable() {
			@Override
			public void run() {
                synchronized (synObj) {  
                	builder = new AlertDialog.Builder(context);
                	builder.setIcon(icon);
                	builder.setTitle(title);
                	builder.setMessage(message);
                	setDialogButtons(builder, eType, positiveListener, negativeListener, neutralListener);
                	builder.create().show();
                }  	
			}
    	});
    } 
    
    protected static void setDialogButtons(	final AlertDialog.Builder builder, 
    										final int eType,
    										final DialogInterface.OnClickListener positiveListener,
    	    								final DialogInterface.OnClickListener negativeListener,
    	    								final DialogInterface.OnClickListener neutralListener) {
    	switch(eType) {
	    	case HFMessageBoxType.eMSGBOX_OK: {
	    		builder.setPositiveButton(MSGBOX_BTN_CAPTION_OK, positiveListener);
	    		break;
	    	}
	    	case HFMessageBoxType.eMSGBOX_OKCancel: {
	    		builder.setPositiveButton(MSGBOX_BTN_CAPTION_OK, positiveListener);
	    		builder.setNegativeButton(MSGBOX_BTN_CAPTION_CANCEL, negativeListener);
	    		break;
	    	}
	    	case HFMessageBoxType.eMSGBOX_AbortRetryIgnore: {
	    		builder.setPositiveButton(MSGBOX_BTN_CAPTION_ABORT, positiveListener);
	    		builder.setNegativeButton(MSGBOX_BTN_CAPTION_RETRY, negativeListener);	  
	    		builder.setNeutralButton(MSGBOX_BTN_CAPTION_IGNORE, negativeListener);		    		
	    		break;
	    	}
	    	case HFMessageBoxType.eMSGBOX_YesNoCancel: {
	    		builder.setPositiveButton(MSGBOX_BTN_CAPTION_YES, positiveListener);
	    		builder.setNegativeButton(MSGBOX_BTN_CAPTION_NO, negativeListener);	  
	    		builder.setNeutralButton(MSGBOX_BTN_CAPTION_CANCEL, negativeListener);	
	    		break;
	    	}
	    	case HFMessageBoxType.eMSGBOX_YesNo: {
	    		builder.setPositiveButton(MSGBOX_BTN_CAPTION_YES, positiveListener);
	    		builder.setNegativeButton(MSGBOX_BTN_CAPTION_NO, negativeListener);	    		
	    		break;
	    	}	    	
	    	case HFMessageBoxType.eMSGBOX_RetryCancel: {
	    		builder.setPositiveButton(MSGBOX_BTN_CAPTION_RETRY, positiveListener);
	    		builder.setNegativeButton(MSGBOX_BTN_CAPTION_CANCEL, negativeListener);	    		
	    		break;
	    	}	  
	    	default: {
	    		builder.setPositiveButton(MSGBOX_BTN_CAPTION_OK, positiveListener);
	    		builder.setNegativeButton(MSGBOX_BTN_CAPTION_CANCEL, negativeListener);	    		
	    		break;
	    	}
    	}
    }
    
    public static class HFMessageBoxIcon {
        public final static int eMsgIconNone = 0;     //     Ϣδš
        public final static int eMsgIconError = 16;   //     Ϣһţ÷һɫԲȦеİɫ X ɵġ
        public final static int eMsgIconHand = 16;    //     Ϣһţ÷һɫԲȦеİɫ X ɵġ
        public final static int eMsgIconStop = 16;    //     Ϣһţ÷һɫԲȦеİɫ X ɵġ
        public final static int eMsgIconQuestion = 32;//     Ϣһţ÷һԲȦеһʺɵġٽʹʺϢͼ꣬ԭǸͼ޷رʾض͵ϢʺʽϢӦκϢ͡⣬ûܽʺϢϢˣ벻ҪϢʹôʺϢšϵͳִ֧˷ֻΪݡ
        public final static int eMsgIconExclamation = 48; //     Ϣһţ÷һɫμеһ̾ɵġ
        public final static int eMsgIconWarning = 48;    //     Ϣһţ÷һɫμеһ̾ɵġ
        public final static int eMsgIconInformation = 64; //     Ϣһţ÷һԲȦеСдĸ i ɵġ
        public final static int eMsgIconAsterisk = 64; //     Ϣһţ÷һԲȦеСдĸ i ɵġ
    };
    
    public static class HFMessageBoxType{
    	public final static int eMSGBOX_OK = 0;                //     Ϣȷť
    	public final static int eMSGBOX_OKCancel = 1;          //     Ϣȷ͡ȡť
    	public final static int eMSGBOX_AbortRetryIgnore = 2;  //     Ϣֹԡ͡ԡť
    	public final static int eMSGBOX_YesNoCancel = 3;      //     Ϣǡ񡱺͡ȡť
    	public final static int eMSGBOX_YesNo = 4;            //     Ϣǡ͡񡱰ť
    	public final static int eMSGBOX_RetryCancel = 5;      //     Ϣԡ͡ȡť
    	public final static int eMSGBOX_Other = 6;            //          
    };
}
