package cnv.hf.widgets;

import hmi.packages.HPInitAPI.HPDrawingMode;
import hmi.packages.HPSysEnv;
import android.R;
import android.content.Context;
import android.graphics.Paint;
import android.graphics.Paint.FontMetrics;
import android.graphics.Rect;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.RotateDrawable;
import android.os.Handler;
import android.os.Message;
import android.text.Editable;
import android.text.InputFilter;
import android.text.InputType;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.FloatMath;
import android.view.MotionEvent;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputConnection;
import android.widget.EditText;
import cnv.hf.widgets.HFWidgetStorage.HFEditStorage;

public class HFEditWidget extends HFTextItem {
	
	private HFWidgetBorder				border;			/*߿*/				
	private int							inputType;		/*1*/
	private HFOnTextChangedInterface 	mOnTextChangedListener = null;
	private HFOnFocusChangedInterface   mOnFocusChangedInterface = null;
	private HFOnRightDrawableClickListener mOnRightClickListener = null;
	/** EditText ҲʾͼƬ*/  
    private Drawable mBoundRightDrawable;
	/** EditTextҲɾť  */
    private Drawable mClearDrawable;
    /** EditTextִʾڼصͼƬ*/
    private RotateDrawable mRotateDrawable;
    private Drawable mHintRightDrawable;
    private int level = 0;  
    /** תֹ߳ͣʶ*/
    private boolean mFlag = false; 
    /** ҲɾťǷ*/
    private boolean isClickable = true; 
	/** ǰ༭Ƿ˽*/
	private boolean isFocused = false;
	public HFEditWidget(Context context, Object widgetData) {
		super(context, widgetData);
		initEditMembers(widgetData);
	}
	@Override
	protected void setHolder(Context context,Object widgetData) {
		setObject(new HFEditText(context));
	}
	/*======================================================
	: ȡĸ߶
	: fontSize [in] С
	ֵ: ĸ߶
	======================================================*/
	protected int getFontHeight(float fontSize) {     
		Paint paint = new Paint();    
		paint.setTextSize(fontSize);    
		FontMetrics fm = paint.getFontMetrics();    
		return (int) FloatMath.ceil(fm.descent - fm.top) + 2; 
	}
	/*======================================================
	: ñ༭
	: 
	ֵ: 
	======================================================*/	
	protected void setMutilines() {
		EditText editText = (EditText)getObject();
		if(	editText != null 
			&& getFont() != null 
			&& getBound() != null) {
			
			int fontHeight = getFontHeight(getFont().getSize());
			if(fontHeight > 0) {
				int widgetHeight = getBound().getHeight();
				int lines = widgetHeight / fontHeight;
				lines = (lines == 0) ? 1 : lines;
				if(lines == 1) {
					editText.setLines(lines);
				}
				else {
					editText.setMinLines(lines);
					editText.setInputType(InputType.TYPE_TEXT_FLAG_MULTI_LINE);
				}
			}
		}
	}
	/*======================================================
	: ʼ
	: widgetData [in] ؼ
	ֵ: 
	======================================================*/
	private void initEditMembers(Object widgetData) {
		HFEditStorage data = (HFEditStorage)widgetData;
		EditText editText = (EditText)getObject();
		if(data != null) {
			setInputType(data.getInputType());
			setBorder(data.getBorder());
			if(editText != null && !(TextUtils.isEmpty(data.getText()))) {
				editText.setHint(data.getText());
				editText.setText("");
			}
		}
		//ö
		setMutilines();
		
		//CCԭ̬ò뷨
		HPSysEnv sysEnv = ((HFModeActivity)editText.getContext()).getSysEnv();
		if(sysEnv != null && sysEnv.getDrawingMode() == HPDrawingMode.eHCDrawingMode_Default)
		   editText.setInputType(InputType.TYPE_NULL);
        mBoundRightDrawable = editText.getCompoundDrawables()[2];  
        
        if(mClearDrawable == null){
        	mClearDrawable = getObject().getContext().getResources().getDrawable(  
                    R.drawable.ic_delete);  
        }
        
        setClearIconVisible(false);  
	}
	
	/*======================================================
	: üϣڼضȻʾɾť
	: 
	ֵ: 
	======================================================*/
	public void setLoadingFinished(){
		mFlag = false;
		if(mClearDrawable == null){
			mClearDrawable = getObject().getResources().getDrawable(android.R.drawable.ic_delete);	
		}
		mBoundRightDrawable = mClearDrawable;
		isClickable = true;
		setRightDrawableBound();
//		int length = 0;
//		if(getText() != null){
//			length = getText().toString().length();
//		}
//		setClearIconVisible(length > 0);
		setRightDrawableState();
	}
      
    Handler handler=new Handler(){  
		public void handleMessage(Message msg) {  
			if(mRotateDrawable != null && mFlag){
				handler.removeMessages(0x00);
				//תǶͬʱʾ
				mRotateDrawable.setLevel(level);  
	            level+=1000;  
	            mBoundRightDrawable = mRotateDrawable;
	            isClickable = false;
	            setRightDrawableBound();
//	            setClearIconVisible(true);	
	            setRightDrawableState();
	            handler.sendEmptyMessageDelayed(0x00, 50);
			}else{
				handler.removeMessages(0x00);
			}
            
        };  
    };  
    
	/*======================================================
	: ڼصĶͼƬ
	: drawable [in]  ԴͼƬ
	ֵ: 
	======================================================*/
    public void setLoadingDrawable(RotateDrawable drawable){
    	if(drawable != null){
    		mRotateDrawable = drawable;
    	}
    }
	

	/*======================================================
	: ɾťıͼƬ
	: drawable [in]  ԴͼƬ
	ֵ: 
	======================================================*/
	public void setClearDrawable(Drawable drawable){
		if(null == drawable){
			return;
		}
		mClearDrawable = drawable;
	}
	
	/*======================================================
	: ɾťıͼƬ
	: resId [int]  ԴͼƬid
	ֵ: 
	======================================================*/
	public void setClearDrawable(int resId){
		mClearDrawable = getObject().getContext().getResources().getDrawable(resId);
	}
	
	/*======================================================
	: ȡؼı߿
	: 
	ֵ: border
	======================================================*/
	public HFWidgetBorder getBorder() {
		return border;
	}
	/*======================================================
	: ÿؼı
	:  border  [in] ߿ɫ
	ֵ: 
	======================================================*/
	public void setBorder(HFWidgetBorder border) {
		this.border = border;
	}
	/*======================================================
	: ȡEdit뷽ʽ
	: 
	ֵ: ؼ뷽ʽ(enumNAVI_HF_INPUTTYPE)
	======================================================*/
	public int getInputType() {
		return inputType;
	}
	/*======================================================
	: Edit뷽ʽ
	: 
	       inputType   [in] 뷽ʽ, enumNAVI_HF_INPUTTYPE
	       
	ֵ: 
	======================================================*/
	public void setInputType(int inputType) {
		this.inputType = inputType;
		EditText edit = (EditText)getObject();
		if(edit == null) {
			return ;
		}
		int type = InputType.TYPE_CLASS_TEXT;
		if(inputType  == HFEditInputType.eInputType_Default) {
			edit.setInputType(InputType.TYPE_CLASS_TEXT);
		}
		else {
			if((inputType | HFEditInputType.eInputType_Numberic) == HFEditInputType.eInputType_Numberic) {
				
				type = InputType.TYPE_CLASS_NUMBER;  
			}				
			if((inputType | HFEditInputType.eInputType_Capital) == HFEditInputType.eInputType_Capital) {
				
				type |= InputType.TYPE_TEXT_FLAG_CAP_CHARACTERS;  
			}
			if((inputType | HFEditInputType.eInputType_Password) == HFEditInputType.eInputType_Password) {
				
				type |= InputType.TYPE_TEXT_VARIATION_PASSWORD;  
			}	
			edit.setInputType(type);	
		}
	}
	/*======================================================
	: ַ
	:  maxLength  [in] Ҫ׷ӵִ
	ֵ: 
	======================================================*/
	public void setMaxLength(int maxLength) {
		EditText edit = (EditText)getObject();
		if(edit != null) {
			edit.setFilters(new InputFilter[]{new InputFilter.LengthFilter(maxLength)});  
		}
	} 
	
	/*======================================================
	: ÿؼҪ׷ӵַ
	:  in_puiText  [in] Ҫ׷ӵִ
	ֵ: 
	======================================================*/
	public void insertText(CharSequence text) {
		EditText edit = (EditText)getObject();
		if(edit != null) {
			edit.append(text);
		}
	} 
	/*======================================================
	: EditдӺɾһַ(BackSpace)
	:  widget                [in] ؼָ
	       in_uiNumOfCharacters     [in] Ҫɾַ
	ֵ: =0: ɹ; > 0: 
	======================================================*/
	public void backSpace(int numOfCharacters) {
		
		EditText edit = (EditText)getObject();
		if(edit != null) {
			Editable text = edit.getText();
			if(text != null) {
				int length = text.length();
				if(length > 0) {
					text.delete(length - 1, length - 1);
				}
			}
		}
	}
	/*======================================================
	: ı
	:  
	ֵ: =0: ɹ>0: 
	======================================================*/
	public void  emptyText() {
		EditText edit = (EditText)getObject();
		if(edit != null) {
			edit.setText("");
		}
	}
	/*======================================================
	: Editйλ(winceݲʵ)
	:  in_uiPosition         [in] λ
	ֵ: 
	======================================================*/
	public void setCursorPosition(int position) {
		EditText edit = (EditText)getObject();
		if(edit != null) {
			edit.setSelection(position);
		}
	}
	/*======================================================
	: Editʼλáλãıѡ(winceݲʵ)
	:  
	       start            [in] ʼλ
	       end              [in] λ
	ֵ: 
	======================================================*/
	public void setSelection(int start, int end) {
		EditText edit = (EditText)getObject();
		if(edit != null) {
			edit.setSelection(start, end);
		}
	}  
	/*======================================================
	: ȡؼOnTextChangeListener
	:  widget  [in] ؼָ
	ֵ: OnTextChangeListenerָ
	======================================================*/	
	public HFOnTextChangedInterface getOnTextChangedListener() {
		return mOnTextChangedListener;
	}
	
	/*======================================================
	: ñ༭Ƿʾɾť
	:  visible  [boolean] Ƿʾ
	ֵ: 
	======================================================*/	
	protected void setClearIconVisible(boolean visible) {  
		EditText editText = (EditText)getObject();
		if(editText == null){
			return;
		}
        Drawable right = visible ? mBoundRightDrawable : null; 
        editText.setCompoundDrawables(editText.getCompoundDrawables()[0],  
        		editText.getCompoundDrawables()[1], right, editText.getCompoundDrawables()[3]);  
    }  
	
	/*======================================================
	: ÿؼOnTextChangeListener
	:  widget                [in] ؼָ
	       in_pListener          [in] OnTextChangeListener
	ֵ: =0: ɹ; > 0: 
	======================================================*/
	private TextWatcher mTextWatcher = null;
	public void setOnTextChangedListener(HFOnTextChangedInterface listener) {
		mOnTextChangedListener = listener;
		if(listener != null && mTextWatcher == null) {
			 mTextWatcher = new HFTextWatcher(this);
			((EditText)getObject()).addTextChangedListener(mTextWatcher);
		}
		if(listener == null &&  mTextWatcher != null){
			((EditText)getObject()).removeTextChangedListener(mTextWatcher);
			mTextWatcher = null;
		}
	}
	//
	public	class 	HFEditInputType	{
		public static final short eInputType_Default	=  0;  	//Ĭ
		public static final short eInputType_Capital	=  1;   //д
		public static final short eInputType_Password	=  2;  	//
		public static final short eInputType_Numberic	=  4;	//ֻ
	} 
	/*======================================================
	:  ıı¼
	:  sender:¼Դ
		  s: ɱ༭ı
	ֵ:
	======================================================*/
	public interface HFOnTextChangedInterface { 
		public void onTextChanged(HFEditWidget sender, Editable s);
	}
	//TextViewؼTextWatcherӿ
	protected class HFTextWatcher implements TextWatcher {
		private HFEditWidget mEdit = null;
		public HFTextWatcher(HFEditWidget edit) {
			mEdit = edit;
		}
		@Override
		public void afterTextChanged(Editable s) {
			if(mEdit != null) {
				HFOnTextChangedInterface listener = mEdit.getOnTextChangedListener();
				if(listener != null) {
					listener.onTextChanged(mEdit, s);
				}
			}
		}
		@Override
		public void beforeTextChanged(CharSequence s, int start, int count,
				int after) {
		}
		@Override
		public void onTextChanged(CharSequence s, int start, int before,
				int count) {
			/*
			 * ༭ߵݲΪʱʾض
			 * ʾضʱȽ֮ǰĽֹͣȻʱ200߳̿
			 * ֻϲonLoadingFinishedֹͣ༭Ϊʱ
			 */
			int length = s.length();
			if(length > 0){
			     mFlag = true;
			     handler.sendEmptyMessageDelayed(0x00, 50);
			}else{
				mFlag = false;
			}
			setRightDrawableState();
		}
	}
	/*======================================================
	:  ıӿ
	:  sender:¼Դ
		  s: ɱ༭ı
	ֵ:
	======================================================*/
	public interface HFOnFocusChangedInterface { 
		public void onFocusChange(View view, boolean hasFocus);
	}
	/*======================================================
	:  ýı¼
	:  lister:ӿ
	ֵ:
	======================================================*/
	public void setOnFocusChangeLister(HFOnFocusChangedInterface lister){
		this.mOnFocusChangedInterface = lister;
	}
	protected class HFEditText extends EditText{

		/** 
		 *@param context
		 */
		public HFEditText(Context context) {
			super(context);
			// TODO Auto-generated constructor stub
			
			//ýı¼̬ʾɾͼ
			setOnFocusChangeListener(new OnFocusChangeListener() {
				
				@Override
				public void onFocusChange(View v, boolean hasFocus) {
					// TODO Auto-generated method stub

					//ýʱʾɾͼ꣬ʧȥʱͼ꣬ǰý㵫ıΪʱɾͼ
//					setClearIconVisible(hasFocus);
					isFocused = hasFocus;
					setRightDrawableState();
					
					if(mOnFocusChangedInterface != null){
						mOnFocusChangedInterface.onFocusChange(getObject(), hasFocus);
					}
				}
			});
		}
		

		/* @˵isInnerWidth, isInnerHeightΪtureɾͼ֮ڣΪɾͼ 
	     * event.getX() ȡӦϽǵX 
	     * event.getY() ȡӦϽǵY 
	     * getWidth() ȡؼĿ 
	     * getHeight() ȡؼĸ߶ 
	     * getTotalPaddingRight() ȡɾͼԵؼұԵľ 
	     * getPaddingRight() ȡɾͼұԵؼұԵľ 
	     * 
	     * getWidth() - getTotalPaddingRight() - width/2 ǰؼһ
	     * getWidth() - getPaddingRight() + width/2 ؼһ
	     */  
		@Override  
	    public boolean onTouchEvent(MotionEvent event) {  
	        if (event.getAction() == MotionEvent.ACTION_UP) {  
	            if (getCompoundDrawables()[2] != null && isClickable) {  
	                if(isClickDrawable(getCompoundDrawables()[2],event,this)){
	                	int state = 1;
	                	if(mBoundRightDrawable == mHintRightDrawable)
	                		state = 1;
	                	else if(mBoundRightDrawable == mClearDrawable)
	                		state = 2;
	                	else if(mBoundRightDrawable == mRotateDrawable)
	                		state = 3;
	                	//ⲿûҲ¼ʱĬϴɾı
	                	if(!(mOnRightClickListener != null && mOnRightClickListener.OnRightDrawableClick(getObject(),state))){
	                		 this.setText("");  
	                	}
	                }
	            }  
	        }else if(event.getAction() == MotionEvent.ACTION_DOWN){
	        	HFModesManager.resetLayoutOnCurrentMode = false;
	        	HFModesManager.lastEditTouchTime = System.currentTimeMillis();
	        }
	        return super.onTouchEvent(event);  
	    }  
		
		/* (non-Javadoc)
		 * @see android.widget.TextView#onCreateInputConnection(android.view.inputmethod.EditorInfo)
		 */
		@Override
		public InputConnection onCreateInputConnection(EditorInfo outAttrs) {
			// TODO Auto-generated method stub
			return super.onCreateInputConnection(outAttrs);
		}
		
	}

	private void setRightDrawableBound(){
		if(mBoundRightDrawable != null){
	        mBoundRightDrawable.setBounds(0, 0, mBoundRightDrawable.getIntrinsicWidth(),  
	                mBoundRightDrawable.getIntrinsicHeight());
		}
		
	}
	
	/** Ĭɫ
	 * @param color
	 * @return void
	 * @author LiangYJ
	 * @date 20151126 5:29:38
	 */ 
	public void setHintTextColor(int color){
		if(getObject() != null){
			((HFEditText)getObject()).setHintTextColor(color);
		}
	}
	
	public interface HFOnRightDrawableClickListener {
		/** Ҳdrawable¼
		 * @param view
		 * @param state Ҳdrawableǰ״̬1hint2clear3loading
		 * @return
		 * @return boolean
		 * @author LiangYJ
		 * @date 20151127 9:11:56
		 */ 
		public boolean OnRightDrawableClick(View view,int state);
	}
	
	/*======================================================
	: ñ༭ҲͼƬ¼
	:  listener  ¼
	ֵ: 
	======================================================*/	
	public void setOnRightDrawableClickListener(HFOnRightDrawableClickListener listener){
		this.mOnRightClickListener = listener;
	}
	
	/*======================================================
	: ñ༭ҲĬͼƬıΪʱʾdrawable
	:  drawable  
	ֵ: 
	======================================================*/	
	public void setHintRightDrawable(Drawable drawable){
		mHintRightDrawable = drawable;
	}
	
	/*======================================================
	 * ܣжdrawableǷ񱻵
	 * drawable
	 *      event
	 *      editText
	 =======================================================*/
	private boolean isClickDrawable(Drawable drawable,MotionEvent event,EditText editText){
		if(drawable == null || event == null)
			return false;
		 int x = (int)event.getX();  
         int y = (int)event.getY();  
		Rect rect = drawable.getBounds();  
        int height = rect.height();  
        int width = rect.width();
        int distance = (editText.getHeight() - height)/2;  
        boolean isInnerWidth = x > (editText.getWidth() - editText.getTotalPaddingRight() - width/2) 
        		&& x < (editText.getWidth() - editText.getPaddingRight() + width/2);  
        boolean isInnerHeight = y > distance && y < (distance + height);  
        return isInnerHeight && isInnerWidth;
	}
	
	/*======================================================
	 * ܣҲdrawableʾ״̬
	 =======================================================*/
	private void setRightDrawableState(){
		String text = getText().toString();
		
		if(mHintRightDrawable != null){
			if(TextUtils.isEmpty(text)){
				mBoundRightDrawable = mHintRightDrawable;
				setRightDrawableBound();
			}
			setClearIconVisible(true);
		}else if(isFocused){
			if(TextUtils.isEmpty(text)){
				setClearIconVisible(false);	
			}else{
				setClearIconVisible(true);
			}
		}else{
			setClearIconVisible(false);
		}
	}
}
