package cnv.hf.widgets;

import java.util.ArrayList;
import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Color;
import android.graphics.Rect;
import android.graphics.drawable.ColorDrawable;
import android.graphics.drawable.Drawable;
import android.os.Handler;
import android.os.Message;
import android.util.AttributeSet;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.AbsListView.OnScrollListener;
import android.widget.AbsoluteLayout.LayoutParams;
import android.widget.AdapterView;
import android.widget.BaseExpandableListAdapter;
import android.widget.Button;
import android.widget.ExpandableListView;
import android.widget.ExpandableListView.OnChildClickListener;
import android.widget.ExpandableListView.OnGroupClickListener;
import android.widget.ListAdapter;
import android.widget.ListView;
import cnv.hf.widgets.HFListWidget.HFListItem.HFListItemType;
import cnv.hf.widgets.HFListWidget.HFListItem.HFListItemTypeExt;
import cnv.hf.widgets.HFListWidget.HFListStyle;
import cnv.hf.widgets.HFWidgetStorage.HFBaseStorage;
import cnv.hf.widgets.HFWidgetStorage.HFExpandableListItemStorage;
import cnv.hf.widgets.HFWidgetStorage.HFExpandableListStorage;
import cnv.hf.widgets.HFWidgetStorage.HFScrollBarStorage;

@SuppressWarnings("deprecation")
public class HFExpandableListWidget extends HFBaseWidget {
  
	private short	gapOfItems;										/*бƫ*/				
	private int 	listStyle;										/*бķ*/
	private int[]   maskCollapseGroups = null;
	private int[]   groupIndexsMapping = null;
	private HFLayerWidget mHeaderView = null;                                /*бͷ*/
	private View mFootorView = null;                                /*б*/
	private ArrayList<HFExpandableListItem> listItems = null; 		/*б*/
	private HFExpandableDelegateWidget mDelegate = null;				/*ListViewؼ*/
	private HFExpandableAdapterWidget mAdapter = null;        	   	/*ȡݵӿ*/
	private HFOnListGroupClickInterface mOnGroupClickListener = null; 	/*Groupص*/
	private HFOnListChildClickInterface mOnChildClickListener = null; 	/*Childص*/
	private HFOnLviGetLayerIdInterface mOnLviGetLayerIdListener = null; /*GroupȡͼIdĻص*/
	private boolean mPullUpEnable = false;                              /*Ƿ*/
	private boolean mPullDownEnable = false;                            /*Ƿ*/
	private OnPullGestureListener mOnHeaderPullDownListener;         /*ˢ¼*/
	private OnPullGestureListener mOnFootorPullUpListener;
	private HFOnItemLongClickListener mOnItemLongClickListener;
	private HFOnTurnPageListener mOnTurnPageListener;
//	private int mFirstVisibleItem = 1;
	
	private HFBaseWidget mButtonWidgetTurnUp;                      /*Ϸҳť*/
	private HFBaseWidget mButtonWidgetTurnDown;                    /*·ҳť*/
	private int mFirstVisibleItem = 0;	
	/** listviewǷײıʶڵײ¹ťdisable*/
	private boolean isLastRow = false;
	private HFScrollBarStorage mScrollBarStorage;                  /*ʽ*/
    private int mHeaderViewHeight;
	private int mOrder = 0;
	private boolean shouldFocus = true;
	private boolean enableLayoutChildFocus = true;
	
	/**
	 * @param enableLayoutChildFocus the enableLayoutChildFocus to set
	 */
	public void setEnableLayoutChildFocus(boolean enableLayoutChildFocus) {
		this.enableLayoutChildFocus = enableLayoutChildFocus;
	}
	
	@SuppressLint("NewApi")
	public HFExpandableListWidget(Context context,Object widgetData) {
		super(context, widgetData);
		ExpandableListView exList = (ExpandableListView)getObject();
		exList.setSelector(new ColorDrawable(Color.TRANSPARENT));
		//б
		listItems = new ArrayList<HFExpandableListItem>();
		//ʼԱ
		initListMembers(widgetData);	
		//
		mDelegate = new HFExpandableDelegateWidget(this);
		//бheader
		if(getHeaderView() != null){
		  ((ExpandableListView)getObject()).addHeaderView(getHeaderView());
		}
		//бfootor
		if(getFootorView() != null){
		  ((ExpandableListView)getObject()).addFooterView(getFootorView());
		}
		//ListViewӿ
		((ExpandableListView)getObject()).setAdapter(mDelegate);
		//ѡʱıɫ
		((ExpandableListView)getObject()).setCacheColorHint(Color.TRANSPARENT);
		//ListView
		((ExpandableListView)getObject()).setGroupIndicator(null);
		((ExpandableListView)getObject()).setFocusable(false);
		((ExpandableListView)getObject()).setFocusableInTouchMode(false);
		((ExpandableListView)getObject()).setFadingEdgeLength(0);
		//ùʽ
		((ExpandableListView)getObject()).setScrollBarStyle(View.SCROLLBARS_OUTSIDE_OVERLAY);
		//ػGroup¼
		((ExpandableListView)getObject()).setOnGroupClickListener(new OnListViewGroupClickListener(this));
		//ػChild¼
		((ExpandableListView)getObject()).setOnChildClickListener(new OnListViewChildClickListener(this));
		//бʽ4ûдˢ»ʱ
		((ExpandableListView)getObject()).setOverScrollMode(ListView.OVER_SCROLL_NEVER);
		//end
		mScrollBarStorage = ((HFExpandableListStorage)widgetData).getScrollBar();
		//added by LiangYJ 20150707
		getObject().post(new Runnable() {
			
			@Override
			public void run() {
				// TODO Auto-generated method stub
				
				//added by LiangYJ 20150724 Ϸ·ť
					
				if(mScrollBarStorage != null){
					mButtonWidgetTurnUp = new HFButtonWidget(getObject().getContext(), mScrollBarStorage.getPageUpButton());
					mButtonWidgetTurnDown = new HFButtonWidget(getObject().getContext(), mScrollBarStorage.getPageDownButton());
						
					ViewGroup viewGroup = (ViewGroup) getObject().getParent();
					if(viewGroup != null && viewGroup instanceof HFLayerWidget){
						HFLayerWidget layerWidget = (HFLayerWidget) viewGroup;
						HFWidgetBound bound = mButtonWidgetTurnUp.getBound();
						layerWidget.addView(mButtonWidgetTurnUp.getObject(),new LayoutParams(bound.getWidth()
								, bound.getHeight(), bound.getLeft(), bound.getTop()));
						bound = mButtonWidgetTurnDown.getBound();
						layerWidget.addView(mButtonWidgetTurnDown.getObject(),new LayoutParams(bound.getWidth()
								, bound.getHeight(), bound.getLeft(), bound.getTop()));
					}
						
					setTurnUpButton(mButtonWidgetTurnUp);
					setTurnDownButton(mButtonWidgetTurnDown);
				}

				setTurnUpButtonEnable(false);
				setTurnDownButtonEnable(!isLastRow);
				//end
			}
		});
		//end
	}
	
	/*======================================================
	: ؼ
	: 
	ֵ: 
	======================================================*/
	@Override
	protected void setHolder(Context context,Object widgetData) {
		setObject(new HFExpandableListView(context));
		//setObject(new ExpandableListView(context));
	}
	
	/*======================================================
	: ʼؼĳԱ
	: widgetData [in] ؼ
	ֵ: ؼ
	======================================================*/
	private void initListMembers(Object widgetData) {
		HFExpandableListStorage data = (HFExpandableListStorage)widgetData;
		if(data != null) {
			setListStyle(data.getListStyle());
			setGapOfItems((short)data.getGapOfItems());
			for(int index =0 ; index < data.getNumOfListItems(); index++) {
				addItem(new HFExpandableListItem(getObject().getContext(), data.getItem(index)));
				if(data.getItem(index).getListItemType() == HFListItemType.eListItemType_Header && data.getItem(index).getListItemTypeExt() == HFListItemTypeExt.inteListItemTypeExt_Pull){
					mPullDownEnable = true;
				}
				if(data.getItem(index).getListItemType() == HFListItemType.eListItemType_Footor && data.getItem(index).getListItemTypeExt() == HFListItemTypeExt.inteListItemTypeExt_Pull){
					mPullUpEnable = true;
				}
			}	
		}
	}
	
	
	
	/*======================================================
	: ȡбheaderView
	: 
	ֵ: headerView
	======================================================*/
	public View getHeaderView(){
		if(mHeaderView == null){
	      for(int i=0; i < getNumOfListItems(); i++){
	    	 HFExpandableListItem item = getItem(i);
	    	 if(item.getListItemType() == HFListItemType.eListItemType_Header) {
	    		HFModeWidget modeWidget = (HFModeWidget)(getObject().getContext());
	 			if(modeWidget != null) {
	 				HFLayerWidget widget = modeWidget.createLayerWidgets(modeWidget.getModeLoader(),item.getGroupLayerWidget()); 
	 				mHeaderView = widget;
	 				mHeaderView.setPadding(mHeaderView.getPaddingLeft(), -mHeaderView.getBound().getHeight(), 
	 						mHeaderView.getPaddingRight(), mHeaderView.getPaddingBottom());
	 				mOrder = 0;
	 				mHeaderViewHeight = HFModesManager.getScaleXY(false, widget.getBound().getHeight());
	 			}
	    		break;
	    	 }
	      }
	      
	      //added by LiangYJ 20150909

	      //orderƶбλãֻûˢµб
    	  HFWidgetBound listBound = getBound();
//    	  Log.v("CLDLOG", "HFExpandableListWidget order:"+getOrder());
	      if(getOrder() > 0 && listBound != null){
	    	  int order = HFModesManager.getScaleXY(false, getOrder());
	    	  if(mHeaderView != null){

		      }else{
		    	  //headerorder߶ȵviewͬʱlistview߶ԭorder߶order
		    	  mHeaderView = new HFLayerWidget(getObject().getContext());
		    	  android.widget.AbsListView.LayoutParams lParams = (android.widget.AbsListView.LayoutParams) mHeaderView.getLayoutParams();
		    	  if(lParams == null){
		    		  lParams = new android.widget.AbsListView.LayoutParams(listBound.getWidth(), order);
		    	  }else{
		    		  lParams.width = listBound.getWidth();
		    		  lParams.height = order;
		    	  }
		    	  mHeaderView.setLayoutParams(lParams);
		    	  listBound.setTop(listBound.getTop() - order);
		    	  listBound.setHeight(listBound.getHeight() + order);
		    	  setBound(listBound);
		    	  mOrder = getOrder();
		      }
	    	 
	      }
	      //end
		}
		return mHeaderView;
	}
	
	/*======================================================
	: ȡбFooterView
	: 
	ֵ: FooterView
	======================================================*/
	public View getFootorView(){
		if(mFootorView == null){
			for(int i=0; i < getNumOfListItems(); i++){
			     HFExpandableListItem item = getItem(i);
		    	 if(item.getListItemType() == HFListItemType.eListItemType_Footor) {
		    		 HFModeWidget modeWidget = (HFModeWidget)(getObject().getContext());
			 		 if(modeWidget != null) {
			 			mFootorView = modeWidget.createLayerWidgets(modeWidget.getModeLoader(),item.getGroupLayerWidget());
			 		 }
		    		 break;
		    	 } 
		    }
		}
		return mFootorView;
	}
	
	/*======================================================
	: ȡб֮ļ
	: 
	ֵ: б֮ļ
	======================================================*/	
	public short getGapOfItems() {
		return gapOfItems;
	}
	/*======================================================
	: б֮ļ
	: gapOfItems [in] б֮ļ
	ֵ: 
	======================================================*/		
	public void setGapOfItems(short gapOfItems) {
		this.gapOfItems = gapOfItems;
		ExpandableListView lv = (ExpandableListView) getObject();
		if(lv != null) {
			lv.setDividerHeight(this.gapOfItems);
		}
	}
	/*======================================================
	: ȡбķ
	: 
	ֵ: бķ
	======================================================*/	
	public int getListStyle() {
		return listStyle;
	}
	/*======================================================
	: бķ
	: listStyle [in] бķ
	ֵ: 
	======================================================*/		
	public void setListStyle(int listStyle) {
		this.listStyle = listStyle;
	}
	/*======================================================
	: ȡбĸ
	: 
	ֵ: бķ
	======================================================*/
	protected int getNumOfListItems() {
		return listItems.size();
	}
	
	/*======================================================
	: ȡбĸ
	: 
	ֵ: бĸ
	======================================================*/
	protected int getNumOfFeatureItems(){
		int count = 0;
		for(int i=0; i < getNumOfListItems(); i++){
		     HFExpandableListItem item = getItem(i);
		     if(item.getListItemType() == HFListItemType.eListItemType_Normal){
		    	 count++;
		     }
		}
		return count;
	}
	/*======================================================
	: һб
	: item [in] б
	ֵ: 
	======================================================*/
	public void addItem(HFExpandableListItem item) {
		listItems.add(item);
	}
	/*======================================================
	: һб
	: item [in] б
	ֵ: 
	======================================================*/
	public HFExpandableListItem addItem() {
		HFExpandableListItem item = new HFExpandableListItem(getObject().getContext(),null);
		addItem(item);
		return item;
	}	
	/*======================================================
	: ȡһб
	: index [in] б
	ֵ: б
	======================================================*/
	public HFExpandableListItem getItem(int index) {
		return listItems.get(index);
	}
	
	/*======================================================
	: ȡͨбб
	ֵ: б
	======================================================*/
	protected HFExpandableListItem getNormalItem() {
		for(int i=0; i < getNumOfListItems(); i++){
		     HFExpandableListItem item = getItem(i);
		     if(item.getListItemType() == HFListItemType.eListItemType_Normal)
		    	 return item;
		}
		return null;
	}
	
	/*======================================================
	: ȡбб
	: index [in] б
	ֵ: б
	======================================================*/
	protected HFExpandableListItem getFeatureItem(int index) {
		int count = 0;
		for(int i=0; i < getNumOfListItems(); i++){
		     HFExpandableListItem item = getItem(i);
		     if(item.getListItemType() == HFListItemType.eListItemType_Normal && count == index){
		    	 return item;
		     }
		     if(item.getListItemType() == HFListItemType.eListItemType_Normal)
		    	 count++;
		}
	   return null;
	}
	
	/*======================================================
	: ȡ
	:  
	ֵ: 
	======================================================*/
	public HFExpandableAdapterWidget getAdapter() {
		return mAdapter;
	}
	/*======================================================
	: 
	:  adapter      [in] 
	ֵ: 
	======================================================*/
	public void setAdapter(HFExpandableAdapterWidget adapter) {
		mAdapter = adapter;
	}
	/*======================================================
	: ȡGroupбĻص
	:  
	ֵ: ص
	======================================================*/	
	public HFOnListGroupClickInterface getOnGroupClickListener() {
		return mOnGroupClickListener;
	}
	/*======================================================
	: GroupбĻص
	:  listener     [in] ص
	ֵ: 
	======================================================*/
	public void setOnGroupClickListener(HFOnListGroupClickInterface listener) {
		this.mOnGroupClickListener = listener;
	}
	/*======================================================
	: ȡChildбĻص
	:  
	ֵ: ص
	======================================================*/		
	public HFOnListChildClickInterface getOnChildClickListener() {
		return mOnChildClickListener;
	}
	/*======================================================
	: ChildбĻص
	:  listener     [in] ص
	ֵ: 
	======================================================*/	
	public void setOnChildClickListener(HFOnListChildClickInterface listener) {
		this.mOnChildClickListener = listener;
	}
	/*======================================================
	: ݸıʱ֪ͨбػб
	:  widget             [in] ؼָ
	ֵ: 
	======================================================*/
	public void notifyDataChanged() {
		if(mDelegate != null) {
			mDelegate.notifyDataSetChanged();
		}
		getObject().postInvalidate();
	}	
	/*======================================================
	: չָGroup
	:  groupPos  [in]  Ҫչgroup
	 
	ֵ: groupչtrue򷵻false(groupѾչfalse)
	======================================================*/	
	public boolean expandGroup(int groupPos) {
		ExpandableListView lv = (ExpandableListView) getObject();
		if(lv != null) {
			if(groupPos == -1){
				for(int i = 0; i < mDelegate.getGroupCount(); i++){
				    lv.collapseGroup(i);
					lv.expandGroup(i);                  
				}
				return true;
			}else{
			    return lv.expandGroup(groupPos);
			}
		}
		return false;
	}
	/*======================================================
	: ָGroup
	:  groupPos  [in]  Ҫgroup
	 
	ֵ: group𣬷true򷵻false(groupѾ𣬷false)
	======================================================*/			
	public boolean collapseGroup(int groupPos) {
		ExpandableListView lv = (ExpandableListView) getObject();
		if(lv != null) {
			if(groupPos == -1){
				for(int i = 0; i < mDelegate.getGroupCount(); i++){
					lv.collapseGroup(i);                  
				}
				return true;
			}else{
			    return lv.collapseGroup(groupPos);
			}
		}
		return false;
	}
	
	/*======================================================
	: ȡgroupIndexs
	: 
	ֵ: GroupIndexs
	======================================================*/	
	public int[] getMaskCollapseGroups(){
		return maskCollapseGroups;
	}
	
	/*======================================================
	: ȡgroupIndexs
	: 
	======================================================*/	
	public void setMaskCollapseGroups(int[] maskCollapseGroups){
		this.maskCollapseGroups = maskCollapseGroups;
	}
	
	/*======================================================
	: groupIndexsӳ
	: 
	ֵ: 
	======================================================*/
	public void setGroupIndexsMapping(int[] groupIndexsMapping){
		this.groupIndexsMapping = groupIndexsMapping;
	}
	
	public int[] getGroupIndexsMapping(){
		return this.groupIndexsMapping;
	}
	
	/*======================================================
	: ָGroupǰչ
	:  groupPosition  [in] group
	 
	ֵ: groupչģtrue򷵻false
	======================================================*/			
	public boolean isGroupExpanded(int groupPosition) {
		ExpandableListView lv = (ExpandableListView) getObject();
		if(lv != null) {
			return lv.isGroupExpanded(groupPosition);
		}			
		return false;
	}	
	/*======================================================
	: ָλõб
	:  index  [in] 
	 
	ֵ: б
	======================================================*/	
	public View getChildAt(int index) {
		ExpandableListView lv = (ExpandableListView) getObject();
		if(lv != null) {
			return lv.getChildAt(index);
		}		
		return null;
	}
	/*======================================================
	: бĸ
	:  
	 
	ֵ: бĸ
	======================================================*/		
	public int getChildCount() {
		ExpandableListView lv = (ExpandableListView) getObject();
		if(lv != null) {
			return lv.getChildCount();
		}		
		return 0;
	}
	/*======================================================
	: Groupбλ÷Groupб
	:  groupPosition [in] бλ
	 
	ֵ: б
	======================================================*/		
	public View getGroup(int groupPosition) {
		ExpandableListView lv = (ExpandableListView) getObject();
		if(lv != null) {
			long packedPosition = ExpandableListView.getPackedPositionForGroup(groupPosition);
			if(packedPosition !=  AdapterView.INVALID_POSITION) {
				int firstVisiblePosition = lv.getFirstVisiblePosition();
				int lastVisiblePosition = lv.getLastVisiblePosition();
				int flatPosition = lv.getFlatListPosition(packedPosition);
				if ((flatPosition != AdapterView.INVALID_POSITION)
				   &&((flatPosition >=  firstVisiblePosition) && (flatPosition <= lastVisiblePosition))) {
					int index = flatPosition - firstVisiblePosition;
					return lv.getChildAt(index);
				}
			} 
		}
		return null;
	}
	/*======================================================
	: GroupChildбλ÷Childб
	:  groupPosition [in] Groupбλ
	 	   childPosition [in] Childбλ
	ֵ: б
	======================================================*/		
	public View getChild(int groupPosition, int childPosition) {
		ExpandableListView lv = (ExpandableListView) getObject();
		if(lv != null) {
			long packedPosition = ExpandableListView.getPackedPositionForChild(groupPosition, childPosition);
			if(packedPosition !=  AdapterView.INVALID_POSITION) {
				int firstVisiblePosition = lv.getFirstVisiblePosition();
				int lastVisiblePosition = lv.getLastVisiblePosition();
				int flatPosition = lv.getFlatListPosition(packedPosition);
				if ((flatPosition != AdapterView.INVALID_POSITION)
				   &&((flatPosition >=  firstVisiblePosition) && (flatPosition <= lastVisiblePosition))) {
					int index = flatPosition - firstVisiblePosition;
					return lv.getChildAt(index);
				}
			} 
		}
		return null;
	}	
	/*======================================================
	: бĸ߶бĸ߶ͬ
	:  
	ֵ: 
	======================================================*/
	public void wrapHeightContent() {
		View view = this.getObject();
		HFWidgetBound bound = this.getBound();
		if(view != null && bound != null) {
			LayoutParams params = (LayoutParams) view.getLayoutParams();
			if(params == null) {
				params = new LayoutParams(	bound.getWidth(),
											LayoutParams.WRAP_CONTENT,
											bound.getLeft(), 
											bound.getTop());
			} else {
				params.height = LayoutParams.WRAP_CONTENT;
			}
			view.setLayoutParams(params);
		}
	}
	/*======================================================
	: ȡgroupListItemͼIdĻص
	:  
	ֵ: ͼId
	======================================================*/	
	public HFOnLviGetLayerIdInterface getOnLviGetLayerIdListener() {
		return mOnLviGetLayerIdListener;
	}
	/*======================================================
	: groupListItemͼIdĻص
	:  listener [in] ͼId
	ֵ: 
	======================================================*/	
	public void setOnLviGetLayerIdListener(HFOnLviGetLayerIdInterface listener) {
		this.mOnLviGetLayerIdListener = listener;
	}
	/*======================================================
	: бҵһб
	: layerName [in] б
	
	ֵ: б
	======================================================*/
	protected int changeOrientation(HFLayerWidget layer) {
		HFLayerWidget listItem = null;
		ExpandableListView listView = (ExpandableListView) getObject();
		if(listView != null) {
			int index;
			for(index = 0; index < listView.getChildCount(); index++) {
				listItem = (HFLayerWidget) listView.getChildAt(index);
				if(listItem.getName().equalsIgnoreCase(layer.getName())) {
					listItem.getBound().setWidth(layer.getBound().getWidth());
					listItem.getBound().setHeight(layer.getBound().getHeight());
					listItem.getBound().setLeft(layer.getBound().getLeft());
					listItem.getBound().setTop(layer.getBound().getTop());
					listItem.changeOrientation(layer);
					if(getListStyle() == HFListStyle.eListStyle_Feature) {
						HFExpandableListItem item = getFeatureItem(listItem.getId());
						if(item != null)
						  listItem.setBackgroundDrawable(item.getBackGroundListDrawable());
					}
					else if(getListStyle() == HFListStyle.eListStyle_Normal){
						HFExpandableListItem item = getNormalItem();
						if(item != null)
						  listItem.setBackgroundDrawable(item.getBackGroundListDrawable());
					}
				}
			}
		}
		return 0;
	}
	/*======================================================
	: ʵͼڵĿؼл
	: widgetData [in] ؼ
	
	ֵ: =0: лɹ; >0: 
	======================================================*/
	protected int changeOrientation(HFBaseStorage widgetData, ArrayList<HFLayerWidget> listLayers) {
		super.changeOrientation(widgetData);
    	HFExpandableListStorage pData = (HFExpandableListStorage)widgetData;
		//ListViewڵListItem,ListItemͼ㣬任ɫ
		if(pData != null) {
			listItems.clear();
			for(int index =0 ; index < pData.getNumOfListItems(); index++) {
				addItem(new HFExpandableListItem(getObject().getContext(), pData.getItem(index)));
			}	
		}
		if(listLayers != null && listLayers.size() > 0) {
			int index;
			HFLayerWidget layer;
			for(index = 0; index < listLayers.size(); index++) {
				layer = listLayers.get(index);
				changeOrientation(layer);
			}
		}
		return 0;
	}		
	public boolean isPullUpEnable() {
		return mPullUpEnable;
	}

	public void setPullUpEnable(boolean mPullUpEnable) {
		this.mPullUpEnable = mPullUpEnable;
	}
	public boolean isPullDownEnable() {
		return mPullDownEnable;
	}

	public void setPullDownEnable(boolean mPullDownEnable) {
		this.mPullDownEnable = mPullDownEnable;
	}
	public OnPullGestureListener getOnHeaderPullDownListener() {
		return mOnHeaderPullDownListener;
	}

	public void setOnHeaderPullDownListener(OnPullGestureListener mOnHeaderPullDownListener) {
		this.mOnHeaderPullDownListener = mOnHeaderPullDownListener;
	}
	public OnPullGestureListener getOnFootorPullUpListener() {
		return mOnFootorPullUpListener;
	}

	public void setOnFootorPullUpListener(OnPullGestureListener mOnFootorPullUpListener) {
		this.mOnFootorPullUpListener = mOnFootorPullUpListener;
	}
	
	public void setOnItemLongClick(HFOnItemLongClickListener itemLongClickListener){
		mOnItemLongClickListener = itemLongClickListener;
	}
	
	public void onHeaderRefreshComplete(){
		HFExpandableListView lv = (HFExpandableListView)getObject();
		lv.onHeaderRefreshComplete();
	}
	public void onFooterRefreshComplete(){
		HFExpandableListView lv = (HFExpandableListView)getObject();
		lv.onFooterRefreshComplete();
	}
	//б
	public class HFExpandableListItem extends HFButtonWidget {
		//private LayerWidget childLayerWidget = null;    //ͼ
	    //private LayerWidget groupLayerWidget = null;    //Groupͼ
		private int 		childLayerWidget;    //ͼ
	    private int 		groupLayerWidget;    //Groupͼ
	    private int        	listItemType;      			//б
	    private int        	listItemTypeExt;   			//бչͣiphoneб
	    
		public HFExpandableListItem(Context context, Object widgetData) {
			super(context, widgetData);
			//бĬ
			setListItemType(HFListItemType.eListItemType_Normal);
			//б
			initListItemMembers(widgetData);
		}
		/*======================================================
		: ʼؼĳԱ
		: widgetData [in] ؼ
		ֵ: ؼ
		======================================================*/
		private void initListItemMembers(Object widgetData) {
			HFExpandableListItemStorage data = (HFExpandableListItemStorage)widgetData;
			if(data != null) {
				//б
				setListItemType(data.getListItemType());
				//бչ
				setListItemTypeExt(data.getListItemTypeExt());
				//Groupͼб
				//setGroupLayerWidget(findLayerById(data.getGrouplayerId()));
				setGroupLayerWidget(data.getGrouplayerId());
				//Childͼб
				//setChildLayerWidget(findLayerById(data.getGrouplayerId()));
				setChildLayerWidget(data.getChildLayerId());
			}
		}
		/*======================================================
		: ͨͼIdȡͼ
		:  
				Id   [in] ͼId
		
		ֵ: ͼ
		======================================================*/
		/*
		private HFLayerWidget findLayerById(int layerId) {
		
			HFModeWidget modeWidget = (HFModeWidget)(getObject().getContext());
			if(modeWidget != null) {
				return modeWidget.findLayerById(layerId);
			}
			return null;
		}
		*/		
		/*======================================================
		: ȡб
		:  
		 
		ֵ: б
		======================================================*/
		public int getListItemType() {
			return listItemType;
		}
		/*======================================================
		: б
		:  in_uiType     [in] б
		ֵ: 
		======================================================*/
		public void setListItemType(int listItemType) {
			this.listItemType = listItemType;
		}
		/*======================================================
		: ȡбչ
		:  
		 
		ֵ: б
		======================================================*/
		public int getListItemTypeExt() {
			return listItemTypeExt;
		}
		/*======================================================
		: бչ
		:  in_uiType     [in] б
		ֵ: 
		======================================================*/
		public void setListItemTypeExt(int listItemTypeExt) {
			this.listItemTypeExt = listItemTypeExt;
		}
		/*======================================================
		: ȡбͼ(Group)
		:  widget        [in]  ؼָ
		 
		ֵ: Groupͼ
		======================================================*/
		public int getGroupLayerWidget() {
			return groupLayerWidget;
		}
		/*======================================================
		: бͼ(Group)
		:  in_pLayerWidget     [in] ͼ
		ֵ: 
		======================================================*/
		public void setGroupLayerWidget(int layer) {
			this.groupLayerWidget = layer;
		}
		/*======================================================
		: ȡбͼ(Child)
		:  widget        [in]  ؼָ
		 
		ֵ: Childͼ
		======================================================*/		
		public int getChildLayerWidget() {
			return childLayerWidget;
		}
		/*======================================================
		: бͼ(child)
		:  widget              [in] ؼָ
		       in_pLayerWidget     [in] ͼ
		ֵ: 
		======================================================*/
		public void setChildLayerWidget(int layer) {
			this.childLayerWidget = layer;
		}	
	}	
	//DelegateWidgetඨ
	public class HFExpandableDelegateWidget extends BaseExpandableListAdapter{
	    //private static final int TYPE_ITEM 		= 0;					//б(б)
	    //private static final int TYPE_SEPARATOR = 1;					//б(ָ)
	    //private static final int TYPE_MAX_COUNT = TYPE_SEPARATOR + 1;	//б͸
		private HFExpandableListWidget mListView = null;					//бؼ
		private HFOnClickListener	mItemClickListener = null;
		public HFExpandableDelegateWidget(HFExpandableListWidget listView) {
			mListView = listView;
			mItemClickListener = new HFOnClickListener(mListView);
		}

		@Override
		public Object getChild(int groupPosition, int childPosition) {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public long getChildId(int groupPosition, int childPosition) {
			// TODO Auto-generated method stub
			return 0;
		}
		protected void setDescendantFocusability(HFLayerWidget lvitem) {
			int index;
			View view = null;
			if(lvitem != null) {
				for(index = 0; index < lvitem.getChildCount(); index++) {
					view = lvitem.getChildAt(index);
					if(view instanceof Button) {
						((Button) view).setOnClickListener(mItemClickListener);
					}
					//view.setSelected(true); ȡѡ״̬µɫ 
				}
				lvitem.setDescendantFocusability(ViewGroup.FOCUS_BLOCK_DESCENDANTS);
			}
		}
		@Override
		public View getChildView(int groupPosition, int childPosition,
				boolean isLastChild, View convertView, ViewGroup parent) {
			int itemIndex = groupPosition;
			HFExpandableListItem listItem = null;
			//бĴ
			int[] groupIndexsMapping = mListView.getGroupIndexsMapping();
			if(groupIndexsMapping != null && groupPosition < groupIndexsMapping.length){
				itemIndex = groupIndexsMapping[groupPosition];
			}
			if(mListView.getListStyle() == HFListStyle.eListStyle_Normal) {
				listItem = mListView.getNormalItem();
				itemIndex = 0;
			}
			else {
				listItem = mListView.getFeatureItem(itemIndex);
			}
			
			if(convertView == null){
				if(listItem != null) {
					convertView = createLayerByListItem(listItem, false);
					if(convertView != null){
						convertView.setId(itemIndex);
						setDescendantFocusability((HFLayerWidget)convertView);
					}
				}
			}
				
			//бΪգûص
			if(convertView != null) {
				long tag = ExpandableListView.getPackedPositionForChild(groupPosition, childPosition);
				((HFLayerWidget)convertView).setTagEx(tag);
				HFExpandableAdapterWidget adapter = mListView.getAdapter();
				if(adapter != null) {
					adapter.getChildData(groupPosition, childPosition, convertView);
				}	
			}				
			return convertView;
		}

		@Override
		public int getChildrenCount(int groupPosition) {
			int count = 0;
			//ǹбַ֧飻бӿڻȡChildĸ
			if(mListView.getListStyle() == HFListStyle.eListStyle_Feature) {
				HFExpandableAdapterWidget adapter = mListView.getAdapter();
				if(adapter != null) {
					count = adapter.getChildCount(groupPosition);
				}
			} else {
				HFExpandableAdapterWidget adapter = mListView.getAdapter();
				if(adapter != null) {
					count = adapter.getChildCount(groupPosition);
				}
			}
			return count;
		}

		@Override
		public Object getGroup(int groupPosition) {
			// TODO Auto-generated method stub
			return null;
		}
		@Override
		public int getGroupCount() {
			int count = 0;
			//ǹбعбĸӻصظ
			HFExpandableAdapterWidget adapter = mListView.getAdapter();
			if(adapter != null) {
				count = adapter.getGroupCount();
			}
			if(	mListView.getListStyle() == HFListStyle.eListStyle_Feature ) {
				if(count < 0 ){//|| count > mListView.getNumOfListItems()){
				   count = mListView.getNumOfFeatureItems();
				}
			} 
			return count;
		}

		@Override
		public long getGroupId(int groupPosition) {
	
			return 0;
		}
		
		@Override
		public View getGroupView(int groupPosition, boolean isExpanded,View convertView, ViewGroup parent) {
			int itemIndex = groupPosition;
			//бĴ
			if(mListView.getListStyle() == HFListStyle.eListStyle_Feature) {
				int[] groupIndexsMapping = mListView.getGroupIndexsMapping();
				if(groupIndexsMapping != null && groupPosition < groupIndexsMapping.length){
					itemIndex = groupIndexsMapping[groupPosition];
				}
				if(convertView == null || (convertView != null && convertView.getId() != itemIndex))
				{
					HFExpandableListItem listItem = mListView.getFeatureItem(itemIndex);
					if(listItem != null) {
						convertView = createLayerByListItem(listItem, true);
						if(convertView != null){
							convertView.setId(itemIndex);
							setDescendantFocusability((HFLayerWidget)convertView);
						}
					}
				}
			} else if(mListView.getListStyle() == HFListStyle.eListStyle_FeaturePreferences) {
				HFExpandableListItem listItem = mListView.getFeatureItem(0);
				HFOnLviGetLayerIdInterface listener = getOnLviGetLayerIdListener();
				if(listener != null) {
					listItem = listener.OnLviGetLayerId(groupPosition, mListView.listItems);
				}	
				if(listItem != null) {
					convertView = createLayerByListItem(listItem, true);
					setDescendantFocusability((HFLayerWidget)convertView);
				}
			}
			else {
				if(convertView == null) {
					HFExpandableListItem listItem = mListView.getNormalItem();
					if(listItem != null) {
						convertView = createLayerByListItem(listItem, true);
						if(convertView != null){
							convertView.setId(itemIndex);
							setDescendantFocusability((HFLayerWidget)convertView);
						}
					}
				}
			}
			//бΪգûص
			if(convertView != null) {
				long tag = ExpandableListView.getPackedPositionForGroup(groupPosition);
				((HFLayerWidget)convertView).setTagEx(tag);
				HFExpandableAdapterWidget adapter = mListView.getAdapter();
				if(adapter != null && ((HFLayerWidget)convertView).getName() != "") {
				   adapter.getGroupData(groupPosition, convertView);
				}	
			}
			return convertView;
		}

		@Override
		public boolean hasStableIds() {

			return true;
		}

		@Override
		public boolean isChildSelectable(int groupPosition, int childPosition) {

			return true;
		}
		/*======================================================
		: ͨͼIdȡͼ
		:  
				Id   [in] ͼId
		
		ֵ: ͼ
		======================================================*/
		protected HFLayerWidget createLayerById(int layerId) {
		
			if(mListView == null || layerId <= -1) {
				return null;
			}
			View view = mListView.getObject();
			if(view == null) {
				return null;
			}
			HFModeWidget modeWidget = (HFModeWidget)(view.getContext());
			if(modeWidget != null) {
				return modeWidget.createLayerWidgets(layerId);
			}
			return null;
		}
		/*======================================================
		: ͨͼIdȡͼ
		:  
				Id   [in] ͼId
		
		ֵ: ͼ
		======================================================*/
		protected HFLayerWidget createLayerByListItem(HFExpandableListItem listItem, boolean isGroup) {
		
			if(listItem == null) {
				return null;
			}
			int layerId = listItem.getGroupLayerWidget();
			if(!isGroup) {
				layerId = listItem.getChildLayerWidget();
			}
			HFLayerWidget layerWidget = createLayerById(layerId);		
			if(isGroup && layerWidget != null) {
				//ͼĬɫȡͼɫΪĬɫ
				Drawable drawable = listItem.getBackGroundListDrawable(layerWidget.getDefaultColor());
				if(drawable != null) {
					layerWidget.setBackgroundDrawable(drawable);
				}
				//layerС߶ȣݲؼ߶ʱʾȫ
				if(layerWidget.getBound() != null)
				    layerWidget.setMinimumHeight(layerWidget.getBound().getHeight());
			}
			return layerWidget;
		}
	} 
	//ӿ
	public interface HFExpandableAdapterWidget {
		
		/*======================================================
		: ȡݸĻص(Group)
		:  
		ֵ: ݸ
		======================================================*/
		public int getGroupCount();
		/*======================================================
		: бĻص(Group)
		:  
		       in_ulIndex    [in] 
		       in_pListItem  [in] ǰб
		ֵ: б
		======================================================*/
		public View getGroupData(int groupIndex, View listItem);
		/*======================================================
		: ȡݸĻص(child)
		:  groupIndex [in] group
		ֵ: ݸ
		======================================================*/		
		public int getChildCount(int groupIndex); 
		/*======================================================
		: бĻص(child)
		:  
		       in_ulIndex    [in] 
		       in_pListItem  [in] ǰб
		ֵ: б
		======================================================*/
		public View getChildData(int groupIndex, int childIndex, View listItem);
	}
	/*======================================================
	:  ؼ¼Ӧ
	:  parent         		[in]  ؼ(ָlistؼ)
	       sender         		[in]  Ŀؼ
	       groupPosition        [in]  
	ֵ:FALSE: ¼δ; 
	       TRUE:¼Ѵ
	======================================================*/
	//Groupص
	public interface HFOnListGroupClickInterface {
		public void OnClick(HFBaseWidget parent, HFLayerWidget sender, int groupPosition);
	}
	/*======================================================
	:  ؼ¼Ӧ
	:  parent         		[in]  ؼ(ָlistؼ)
	       sender         		[in]  Ŀؼ
	       groupPosition        [in]  
	ֵ:FALSE: ¼δ; 
	       TRUE:¼Ѵ
	======================================================*/
	//Childص
	public interface HFOnListChildClickInterface {
		public void OnClick(HFBaseWidget parent, HFLayerWidget sender, int groupPosition, int childPosition);
	}
	/*======================================================
	:  	listItemȡIdĻص
	:  	groupPosition   [in]  
			lviDatas		[in]  б		
	ֵ: 	> 0 ͼId;
	 		<= 0 ʧ
	 
	======================================================*/
	public interface HFOnLviGetLayerIdInterface {
		public HFExpandableListItem OnLviGetLayerId(int position, ArrayList<HFExpandableListItem> lviDatas);
	}	
	//listviewGroup¼
	public class OnListViewGroupClickListener implements OnGroupClickListener {
		private HFExpandableListWidget mListWidget = null;
		public OnListViewGroupClickListener(HFExpandableListWidget parent) {
			mListWidget = parent;
		}
		@Override
		public boolean onGroupClick(ExpandableListView parent, View v,
				int groupPosition, long id) {
			if(mListWidget != null) {
				HFOnListGroupClickInterface listener = mListWidget.getOnGroupClickListener();
				if(listener != null) {
					listener.OnClick(mListWidget, (HFLayerWidget)v, groupPosition);
				}
				HFExpandableAdapterWidget adapter = mListWidget.getAdapter();
				if(adapter != null){
					int childcount = adapter.getChildCount(groupPosition);
					if(childcount <= 0)
						return true;
				}
				int[] maskCollapseGroups = mListWidget.getMaskCollapseGroups();
				if(maskCollapseGroups != null){
					for(int i = 0; i < maskCollapseGroups.length; i++)
						if(maskCollapseGroups[i] == groupPosition)
							return true;
				}
			}
			return false;
		}
	}
	//listviewChild¼
	public class OnListViewChildClickListener implements OnChildClickListener {
		private HFExpandableListWidget mListWidget = null;
		public OnListViewChildClickListener(HFExpandableListWidget parent) {
			mListWidget = parent;
		}
		@Override
		public boolean onChildClick(ExpandableListView parent, View v,
				int groupPosition, int childPosition, long id) {
			if(mListWidget != null) {
				HFOnListChildClickInterface listener = mListWidget.getOnChildClickListener();
				if(listener != null) {
					listener.OnClick(mListWidget, (HFLayerWidget)v, groupPosition, childPosition);
				}
			}
			return false;
		}
	}
	
	public interface OnPullGestureListener {
		public void onBegin(View view);
		public void onTouchScroll(View view,int moveY);
		public void onRefresh(View view);
		public void onFinish(View view);
		public void onFlingStop(View view);
	}
	
	public interface HFOnItemLongClickListener {
		public void onItemLongClick(View view,boolean isGroup,int groupPosition,int childPosition);
	}
	 
	//listView
	protected class HFExpandableListView extends ExpandableListView implements OnScrollListener,android.widget.AdapterView.OnItemLongClickListener{
		private static final int REFRESH_STATE_NONE = 0;//
		private static final int REFRESH_STATE_PULL = 2;//
		private static final int REFRESH_STATE_RELEASE = 3;//ɿˢ
		private static final int REFRESH_STATE_REFRESHING = 4;   //ˢ
		private static final int LOAD_MORE_STATE_PULL = 5;//
		private static final int LOAD_MORE_STATE_RELEASE = 6;//ɿˢ
		private static final int LOAD_MORE_STATE_REFRESHING = 7;   //ڼظ
		private int mCurrentScrollState;
		private int mLastScrollState;
	    private int mFooterViewHeight;
	    private int mHeaderOriginalTopPadding = -200;
	    private int mFooterOriginalBottomPadding;
	    private int mFooterOriginalTopPadding;
		private int mRefreshState = REFRESH_STATE_NONE;
		private int mLastMotionY;
		private float mDownMotionY = -1;
		private int mDistanceFooter2Bottom = 0;//footerбײľ
		private boolean mHeaderBounce;
		private boolean mIsBegined = false;//ǷѾʼֻеʱִ
		private OnScrollListener mScrollListener = null;
		public HFExpandableListView(Context context) {
			super(context);
			super.setOnScrollListener(this);
			super.setOnItemLongClickListener(this);
		}
		public HFExpandableListView(Context context, AttributeSet attrs) {
			super(context, attrs);
			super.setOnScrollListener(this);
			super.setOnItemLongClickListener(this);
		}		
		public HFExpandableListView(Context context, AttributeSet attrs,
				int defStyle) {
			super(context, attrs, defStyle);
			super.setOnScrollListener(this);
			super.setOnItemLongClickListener(this);
		}
		
		
		/*======================================================
		:ûΪֹhmiͻArrayList
		:  	
		ֵ: 
		=====================================================*/
		@Override
		public void setOnScrollListener(OnScrollListener listen){
			mScrollListener = listen;
		}
		@Override
		public void onScrollStateChanged(AbsListView view, int scrollState) {
			// TODO Auto-generated method stub
//			Log.v("SL", "onScrollStateChanged scrollState:"+scrollState);
			mLastScrollState = mCurrentScrollState;
			mCurrentScrollState = scrollState;
//			if (mCurrentScrollState == SCROLL_STATE_IDLE || mLastScrollState == SCROLL_STATE_FLING) {
//		        // int position = getFirstVisiblePosition();
//		    }
			
			if(mScrollListener != null){//صhmiļ
				mScrollListener.onScrollStateChanged(view, scrollState);
			}
			
			//һֹͣʱִм
			if(scrollState == AbsListView.OnScrollListener.SCROLL_STATE_IDLE){
				
				//һУ¹ťЧ
				setTurnDownButtonEnable(!isLastRow);
				
				//ǹϰťЧ
				View v = view.getChildAt(0);  
				int top = (v == null) ? 0 : v.getTop();  
//				Log.v("CLDLOG", "top:"+top+";first visible item:"+mFirstVisibleItem);
				
				if(((mPullDownEnable && (mFirstVisibleItem == 1 || mFirstVisibleItem == 0))||(!mPullDownEnable && mFirstVisibleItem == 0)) && top >= 0)
//				if(top == 0 && mFirstVisibleItem == 0)
					setTurnUpButtonEnable(false);
				else
					setTurnUpButtonEnable(true);
				
				if(mOnTurnPageListener != null){
					mOnTurnPageListener.scrolledToItem(mFirstVisibleItem);
				}
			}
		}
		@Override
		public void onScroll(AbsListView view, int firstVisibleItem,
				int visibleItemCount, int totalItemCount) {
			// TODO Auto-generated method stub
//			Log.v("SL", "onScroll mRefreshState:"+mRefreshState);
			
			//added by LiangYJ 20150707
			if(totalItemCount == 0){
				isLastRow = true;
			}
			
			//жǷһ
			if (firstVisibleItem + visibleItemCount == totalItemCount) {
			    isLastRow = true;
			}else {
				isLastRow = false;	
			}
			
			mFirstVisibleItem = firstVisibleItem;
			//end
			
			if(mPullDownEnable || mPullUpEnable){
			    if(mCurrentScrollState == SCROLL_STATE_TOUCH_SCROLL 
			    		&& mRefreshState != REFRESH_STATE_REFRESHING
						&& mRefreshState != LOAD_MORE_STATE_REFRESHING){
			    	 if (firstVisibleItem == 0 && mPullDownEnable) {
//			    		 Log.v("CLDLOG", "header bottom:"+getHeaderView().getBottom()+";header top:"+getHeaderView().getTop()+";mHeaderViewHeight:"+mHeaderViewHeight);
			                if ((getHeaderView() != null && (getHeaderView().getBottom() >= mHeaderViewHeight + 20))
			                        && mRefreshState != REFRESH_STATE_RELEASE) {
			                    mRefreshState = REFRESH_STATE_RELEASE;
			                    if(mOnHeaderPullDownListener != null){
//			                    	Log.v("CLDLOG", "pull down begin");
			                    	mOnHeaderPullDownListener.onBegin(getHeaderView());
			                    }
			                } else if (getHeaderView() != null && getHeaderView().getBottom() < mHeaderViewHeight + 20
			                        && mRefreshState != REFRESH_STATE_PULL) {
			                    if (mRefreshState != REFRESH_STATE_NONE) {
			                    
			                    }
			                    mRefreshState = REFRESH_STATE_PULL;
			                    if(mOnHeaderPullDownListener != null){
//			                    	Log.v("CLDLOG", "pull down finish");
			                    	mOnHeaderPullDownListener.onFinish(getHeaderView());
			                    }
			                }
			                if(mOnHeaderPullDownListener != null){
			                	mOnHeaderPullDownListener.onTouchScroll(getHeaderView(),getHeaderView().getBottom());
			                }
			            }
			    	 else if(mPullUpEnable && mCurrentScrollState == SCROLL_STATE_TOUCH_SCROLL 
								&& mRefreshState != REFRESH_STATE_REFRESHING
								&& mRefreshState != LOAD_MORE_STATE_REFRESHING){
//			    		 Log.v("CLDLOG", "footer bottom:"+getFootorView().getBottom()+";footer top:"+getFootorView().getTop()+";mDistanceFooter2Bottom:"+mDistanceFooter2Bottom);
			    		 int footerTop = 0;
			    		 int distance = 0;
			    		 if(getFootorView() != null){
			    			 footerTop = getFootorView().getTop();
					            //бĸ߶ȼȥfooterĶ߶ȵĲֵ
					         distance = getMeasuredHeight() - 
					            		(getFootorView().getTop() + getFootorView().getMeasuredHeight() 
					            				- getFootorView().getPaddingBottom() - getFootorView().getPaddingTop()); 
			    		 }
			    		 
//			    		 Log.v("CLDLOG", "onScroll foot top:"+footerTop);
			    		    
				            if(footerTop != 0 && getFootorView().getPaddingBottom() != 0 && footerTop + 20 < getMeasuredHeight()){
				            	
				            	if(mRefreshState != LOAD_MORE_STATE_RELEASE){
				            		mRefreshState = LOAD_MORE_STATE_RELEASE;
//				                    mFirstVisibleItem = firstVisibleItem + 1;
				            	}
				            	if(mDistanceFooter2Bottom < 0 || mDistanceFooter2Bottom == getMeasuredHeight()){
				            		mDistanceFooter2Bottom = 0;
				            	}
				            	
				            	if(distance - mDistanceFooter2Bottom > 50 && !mIsBegined){
				            		HFLayerWidget lastVisibleView = (HFLayerWidget) getChildAt(visibleItemCount - 1);
				            		if(lastVisibleView.getId() == getFootorView().getId()){
//				            			Log.v("CLDLOG", "onScroll foot top onBegin:"+footerTop+";height:"+getMeasuredHeight()+";padding bottom:"+getFootorView().getPaddingBottom() );
					            		mIsBegined = true;
					                    if(mOnFootorPullUpListener != null){
//					                    	Log.v("CLDLOG", "pull up begin");
					            			mOnFootorPullUpListener.onBegin(getFootorView());
					            		}	
				            		}else{
				            			mIsBegined = false;
				            		}
						    		
				            	}else if(distance - mDistanceFooter2Bottom <= 50 && mIsBegined){
				            		mDistanceFooter2Bottom = 0;
				            		mIsBegined = false;
				            		if(mOnFootorPullUpListener != null){
//				                    	Log.v("CLDLOG", "pull up finish");
				            			mOnFootorPullUpListener.onFinish(getFootorView());
				            		}
				            	}
				            	if(mOnFootorPullUpListener != null){
				                	mOnFootorPullUpListener.onTouchScroll(getFootorView(),distance);
				                }
				            }
				            
//				            Log.v("SL", "footerTop:"+footerTop+";distance:"+distance);
			    		 
//							if(getChildAt(getLastVisiblePosition() - getFirstVisiblePosition()) != null
//									&& getChildAt(
//											getLastVisiblePosition()
//													- getFirstVisiblePosition()).getBottom() <= getMeasuredHeight()){
////				            	if ((getFootorView().getBottom() >= mFooterViewHeight + 20 || getFootorView().getBottom() >= 0)
////				                        && mRefreshState != REFRESH_STATE_RELEASE) {
//				                    mRefreshState = LOAD_MORE_STATE_RELEASE;
//				                    mFirstVisibleItem = firstVisibleItem + 1;
////				                } else if (getHeaderView().getBottom() < mHeaderViewHeight + 20
////				                        && mRefreshState != REFRESH_STATE_PULL) {
////				                    if (mRefreshState != REFRESH_STATE_NONE) {
////				                    
////				                    }
////				                    mRefreshState = REFRESH_STATE_PULL;
////				                }
//				                if(mOnFootorPullUpListener != null){
//				                	mOnFootorPullUpListener.onTouchScroll(getFootorView(),getFootorView().getBottom());
//				                }
//				            } 
						}
			    }else if(mCurrentScrollState == SCROLL_STATE_FLING
		                && firstVisibleItem == 0 && mRefreshState != REFRESH_STATE_REFRESHING){
			    	if(mPullDownEnable){
			    		setSelection(1);
			    	}
			    	    
			        mHeaderBounce = true;
			    }else if(mHeaderBounce && mCurrentScrollState == SCROLL_STATE_FLING){
			    	if(mPullDownEnable){
			    		setSelection(1);
			    	}
			    }
			}
			if(mScrollListener != null){//صhmiļ
				mScrollListener.onScroll(view, firstVisibleItem, visibleItemCount, totalItemCount);
			}
		}
		
		 @Override
		 protected void onAttachedToWindow() {
		    super.onAttachedToWindow();
		    if(mPullDownEnable == true){
//	    		setSelection(1);
	    	}
		 }
		 
		 @Override
		 public void setAdapter(ListAdapter adapter) {
		    super.setAdapter(adapter);
		    if(mPullDownEnable == true && getHeaderView() != null){
//		      mHeaderViewHeight = getHeaderView().getMeasuredHeight();
		      mHeaderOriginalTopPadding = getHeaderView().getPaddingTop() - mOrder;
		      setSelection(1);
		    	
		    }
		    
		    if(mPullUpEnable && getFootorView() != null){
		    	mFooterViewHeight = getFootorView().getMeasuredHeight();
		    	mFooterOriginalBottomPadding = getFootorView().getPaddingBottom();
		    	mFooterOriginalTopPadding = getFootorView().getPaddingTop();
		    }
		 }

		
		@Override
		public boolean onTouchEvent(MotionEvent event) {
			final int y = (int) event.getY();
//			Log.v("SL", "onTouchEvent mRefreshState:"+mRefreshState);
			mHeaderBounce = false;
	        if(mPullDownEnable == true || mPullUpEnable == true){
			    switch (event.getAction()) {
			        case MotionEvent.ACTION_UP:
			            if (!isVerticalScrollBarEnabled()) {
			                setVerticalScrollBarEnabled(true);
			            }
			            
//	            		if(mIsBegined && mOnFootorPullUpListener != null){
//	            			mIsBegined = false;
//	            			mOnFootorPullUpListener.onFinish(getFootorView());
//	            		}
			            
			            int footerTop = 0;
			    		int distance = 0;
			    		if(getFootorView() != null){
			    			 footerTop = getFootorView().getTop();
					         //бĸ߶ȼȥfooterĶ߶ȵĲֵ
					         distance = getMeasuredHeight() - 
					            		(getFootorView().getTop() + getFootorView().getMeasuredHeight() 
					            				- getFootorView().getPaddingBottom() - getFootorView().getPaddingTop());

			    		}
			           			            
			            if (getFirstVisiblePosition() == 0 && mRefreshState != REFRESH_STATE_REFRESHING) {
			            	if ((getHeaderView() != null && (getHeaderView().getBottom() >= mHeaderViewHeight
			                        || getHeaderView().getTop() >= 0))
			                        && mRefreshState == REFRESH_STATE_RELEASE) {
			                    mRefreshState = REFRESH_STATE_REFRESHING;
			                    onPrepareForRefresh();
			                    if(mOnHeaderPullDownListener != null)
			                    	mOnHeaderPullDownListener.onRefresh(getHeaderView());
			                } else if (getHeaderView() != null && (getHeaderView().getBottom() < mHeaderViewHeight
			                        || getHeaderView().getTop() <= 0)) {
			                    resetHeader();
			                    if(mPullDownEnable)
			      		            setSelection(1);
			                }
			            }else if(mPullUpEnable && footerTop != 0 && footerTop + 20 < getMeasuredHeight()
			            		&& mRefreshState != LOAD_MORE_STATE_REFRESHING){
			            	if(mDistanceFooter2Bottom < 0 || mDistanceFooter2Bottom == getMeasuredHeight()){
			            		mDistanceFooter2Bottom = 0;
			            	}
			            	if(distance - mDistanceFooter2Bottom > 50 && mRefreshState == LOAD_MORE_STATE_RELEASE && mIsBegined){
			            		mRefreshState = LOAD_MORE_STATE_REFRESHING;
			                    onPrepareForLoadMore();
			                    if(mOnFootorPullUpListener != null){
			                    	mIsBegined = false;
			                    	mOnFootorPullUpListener.onFinish(getFootorView());
			                    	mOnFootorPullUpListener.onRefresh(getFootorView());  
			                    }
			                    	
			            	}else{
//			            		resetFooter();
//			            		setSelection(mFirstVisibleItem);

			            		resetHeaderPadding();
			            		resetFooterPadding();
			            	}
			            }
//			            else if(getChildAt(getLastVisiblePosition() - getFirstVisiblePosition()) != null
//								&& getChildAt(
//										getLastVisiblePosition()
//												- getFirstVisiblePosition()).getBottom() <= getMeasuredHeight()
//								&& mRefreshState != LOAD_MORE_STATE_REFRESHING){
//			            	Log.v("SL", "-------------- bbbbbbbbbbbbbbbbbb");
//			            	if(getBottom() > getFootorView().getBottom() && mRefreshState == LOAD_MORE_STATE_RELEASE){
//			            		mRefreshState = LOAD_MORE_STATE_REFRESHING;
//			            		Log.v("SL", "-------------- bbbbbbbbbbbbbbbbbb2222222222222");
//			                    onPrepareForLoadMore();
//			                    if(mOnFootorPullUpListener != null)
//			                    	mOnFootorPullUpListener.onRefresh(getFootorView());
//			            	}else{
//			            		Log.v("SL", "-------------- bbbbbbbbbbbbbbbbbb333333333333");
//			            		resetFooter();
//			            		setSelection(mFirstVisibleItem);
//			            	}
//			            	
//			            	
//			            }
			            else {
			            	resetFooterPadding();
//		            		setSelection(mFirstVisibleItem);
			            }
			            
			            mLastMotionY = 0;
			            mDownMotionY = -1;
			            mDistanceFooter2Bottom = 0;
			            break;
			        case MotionEvent.ACTION_DOWN:
			        	mDownMotionY = event.getY();
			        	if(getFootorView() != null){
			        		View bottomChildView = getChildAt(getLastVisiblePosition() - getFirstVisiblePosition());
			        		if(bottomChildView != null && bottomChildView != getFootorView())
			        			mDistanceFooter2Bottom = -1;//0Ļֻ»ȡ
			        		else
			        		    mDistanceFooter2Bottom = getMeasuredHeight() - getFootorView().getBottom();
			        	}
			        	    
			            break;
			        case MotionEvent.ACTION_MOVE:
			            applyPadding(event);
			            break;
			    }
	        }
		   return super.onTouchEvent(event);
		}
		
		private void onPrepareForRefresh() {
		        resetHeaderPadding();
		        resetFooterPadding();
		        mRefreshState = REFRESH_STATE_REFRESHING;
		}
		
		private void onPrepareForLoadMore(){
			resetHeaderPadding();
			resetFooterPadding();
			mRefreshState = LOAD_MORE_STATE_REFRESHING;
		}
		
		private void resetHeader() {
	        if (mRefreshState != REFRESH_STATE_NONE) {
	            mRefreshState = REFRESH_STATE_NONE;
	        }
            resetHeaderPadding();
		}
		
		private void resetFooter() {
	        if (mRefreshState != REFRESH_STATE_NONE) {
	            mRefreshState = REFRESH_STATE_NONE;
	        }
            resetFooterPadding();
		}
	  /**
	   * ˢɣû
	   */
	  public void onHeaderRefreshComplete() {        
	        resetHeader();
	        if (getHeaderView().getBottom() > 0) {
	            invalidateViews();
	            setSelection(1);
	        }
	    }
	  
	  /**
	   * ɣû
	   */
	  public void onFooterRefreshComplete() {        
	        resetFooter();
////	        if (getFootorView().getBottom() > 0) {
////	            invalidateViews();
////	            setSelection(1);
////	        }
////	        setSelection(getCount() - 1);
//	        setSelection(mFirstVisibleItem);
	    }
		
	  /**
	   * ָHeader paddingǰ
	   */
		private void resetHeaderPadding() {
			if(getHeaderView() == null)
				return;
			if(mRefreshState == REFRESH_STATE_REFRESHING){
				getHeaderView().setPadding(getHeaderView().getPaddingLeft(),
						0, getHeaderView().getPaddingRight(),
						getHeaderView().getPaddingBottom());
			}else{
				getHeaderView().setPadding(getHeaderView().getPaddingLeft(),
						-mHeaderView.getBound().getHeight() + mOrder, getHeaderView().getPaddingRight(),
						getHeaderView().getPaddingBottom());	
			}
			if(mRefreshState != REFRESH_STATE_NONE 
					&& mRefreshState != REFRESH_STATE_REFRESHING
					&& mRefreshState != LOAD_MORE_STATE_REFRESHING)
        		mRefreshState = REFRESH_STATE_NONE;
		}
		/**
		   * ָFooter paddingǰ
		   */
	    private void resetFooterPadding() {
	    	if(getFootorView() == null)
	    		return;
			getFootorView().setPadding(getFootorView().getPaddingLeft(),
					mFooterOriginalTopPadding, getFootorView().getPaddingRight(),
					mFooterOriginalBottomPadding);
			if(mRefreshState != REFRESH_STATE_NONE
					&& mRefreshState != REFRESH_STATE_REFRESHING
					&& mRefreshState != LOAD_MORE_STATE_REFRESHING)
        		mRefreshState = REFRESH_STATE_NONE;
		}
		/**
		 * Padding,ԴﵽЧ
		 * @param ev
		 */
		private void applyPadding(MotionEvent ev) {
//			Log.v("SL", "applyPadding mRefreshState:"+mRefreshState);
	        int pointerCount = ev.getHistorySize();
	        if(pointerCount <= 0 )
	        	return;

        	int historicalY = (int) ev.getHistoricalY(pointerCount-1);
        	
	        if((mRefreshState == REFRESH_STATE_RELEASE || mRefreshState == REFRESH_STATE_PULL) && mPullDownEnable){
		        if(mLastMotionY == 0)
		        	mLastMotionY = historicalY;
		        else{
		        	// ϶һfooterʱˢfooter
		        	View bottomChildView = getChildAt(getLastVisiblePosition() - getFirstVisiblePosition());
					if (mLastMotionY > historicalY && mPullUpEnable && bottomChildView != null && bottomChildView == getFootorView()) {
						mRefreshState = LOAD_MORE_STATE_PULL;
						applyFooterPadding(historicalY);
					} else {
						applyHeaderPadding(historicalY);
					}
		        }
		            
	        }else if(mRefreshState == LOAD_MORE_STATE_RELEASE && mPullUpEnable){
		        if(mLastMotionY == 0)
		        	mLastMotionY = historicalY;
		        else{
		        	
		        	View topChildView = getChildAt(0);
					if (mLastMotionY < historicalY && mPullDownEnable && topChildView != null && topChildView == getHeaderView()) {
						mRefreshState = REFRESH_STATE_PULL;
						applyHeaderPadding(historicalY);
					} else {
						applyFooterPadding(historicalY);
					}
		        	
		        }
		        	
	        }else if(mRefreshState == REFRESH_STATE_NONE){//ڵײϻʱᴥonScroll
	        	if(mDownMotionY == -1){
	        		mDownMotionY = ev.getY();
	        	}
	        	int footerTop = 0;
	        	int distance = 0;
	            if(getFootorView() != null){
	            	footerTop = getFootorView().getTop();
		            //бĸ߶ȼȥfooterĶ߶ȵĲֵ
		            distance = getMeasuredHeight() - 
		            		(getFootorView().getTop() + getFootorView().getMeasuredHeight() 
		            				- getFootorView().getPaddingBottom() - getFootorView().getPaddingTop());
		        	
	            }
	            
	            if(mDownMotionY > ev.getY() && getFootorView() != null && mPullUpEnable){//
	            	if(mDistanceFooter2Bottom == 0){
	            		mDistanceFooter2Bottom = getMeasuredHeight() - getFootorView().getBottom();
	            	}
		            if(footerTop != 0 && (distance == 0 || getFootorView().getPaddingBottom() < distance)){//Ϊ0ڵײ
		            	mRefreshState = LOAD_MORE_STATE_RELEASE;
		            }
	        	}else if(mDownMotionY < ev.getY() && getHeaderView() != null && mPullDownEnable){//
	        		getHeaderView().setPadding(
	                		getHeaderView().getPaddingLeft(),
	                		getHeaderView().getPaddingTop() + 5,
	                        getHeaderView().getPaddingRight(),
	                        getHeaderView().getPaddingBottom());
	        	}
	        }
	    }
		
		private void applyHeaderPadding(int historicalY){
			if (getHeaderView() != null) {
				getHeaderView().setPadding(
						getHeaderView().getPaddingLeft(),
						(historicalY - mLastMotionY) / 3,
						getHeaderView().getPaddingRight(),
						getHeaderView().getPaddingBottom());
			}
		}
		private void applyFooterPadding(int historicalY){
			if (getFootorView() != null) {
				getFootorView().setPadding(
						getFootorView().getPaddingLeft(),
						mFooterOriginalTopPadding,
						getFootorView().getPaddingRight(),
						(historicalY + mLastMotionY) / 2);
			}
		}
		
		 @Override
		 protected int computeVerticalScrollOffset() {//Ҫλ
		    int offset = super.computeVerticalScrollOffset();
		    //if(mPullDownEnable == true && mRefreshState == TAP_TO_REFRESH)
		    //	offset-=mHeaderViewHeight;
		    return offset;
		 }
		/**
		 * @see android.widget.AdapterView.OnItemLongClickListener#onItemLongClick(android.widget.AdapterView, android.view.View, int, long)
		 */
		@Override
		public boolean onItemLongClick(AdapterView<?> parent, View view,
				int position, long id) {
			// TODO Auto-generated method stub
			if(view instanceof HFLayerWidget){
				HFLayerWidget layerWidget = (HFLayerWidget) view;
//				Log.v("CLDLOG", "position:"+ ExpandableListView.getPackedPositionGroup(layerWidget.getTagEx()));
//				Log.v("CLDLOG", "layerwidget isGroup:"+layerWidget.isGroupLayer());
				int groupPosition = ExpandableListView.getPackedPositionGroup(layerWidget.getTagEx());
				int childPosition = ExpandableListView.getPackedPositionChild(layerWidget.getTagEx());
//				Log.v("CLDLOG", "onItemLongClick group index:"+groupPosition);
//				if(!isGroup){
//				Log.v("CLDLOG", "onItemLongClick child index:"+childPosition);			
//				}
				if(mOnItemLongClickListener != null){
					mOnItemLongClickListener.onItemLongClick(view, childPosition == -1, groupPosition, childPosition);
				}
			}
			return true;
		}
		
		/* (non-Javadoc)
		 * @see android.view.ViewGroup#requestFocus(int, android.graphics.Rect)
		 */
		@Override
		public boolean requestFocus(int direction, Rect previouslyFocusedRect) {
			// TODO Auto-generated method stub
			if(!enableLayoutChildFocus && !shouldFocus) {
				return false;
			}
			return super.requestFocus(direction, previouslyFocusedRect);
		}
	   
		/* (non-Javadoc)
		 * @see android.widget.ListView#layoutChildren()
		 */
		@Override
		protected void layoutChildren() {
			// TODO Auto-generated method stub
			shouldFocus = false;
			super.layoutChildren();
			shouldFocus = true;
		}
	}
	
	protected class HFOnClickListener implements OnClickListener {
		private HFExpandableListWidget mListWidget = null;
		public HFOnClickListener(HFExpandableListWidget parent) {
			mListWidget = parent;
		}
		@Override
		public void onClick(View v) {
			int groupPosition = -1;
			int childPosition = -1;
			if(mListWidget == null) {
				return ;
			}
			View child = getParent(v);
			if(child == null) { 
				return ;
			}
			if(!(child instanceof HFLayerWidget)) {
				return ;
			}
			HFLayerWidget  listItem = (HFLayerWidget) child;
			long packedPosition = listItem.getTagEx();
			int type = ExpandableListView.getPackedPositionType(packedPosition);
			if (type == ExpandableListView.PACKED_POSITION_TYPE_CHILD) {
				groupPosition = ExpandableListView.getPackedPositionGroup(packedPosition);
				childPosition = ExpandableListView.getPackedPositionChild(packedPosition);
				HFOnListChildClickInterface listener = mListWidget.getOnChildClickListener();
				if(listener != null) {
					listener.OnClick(mListWidget, listItem, groupPosition, childPosition);
					mListWidget.notifyDataChanged();
				}
			}
			else
			if(type == ExpandableListView.PACKED_POSITION_TYPE_GROUP){
				groupPosition = ExpandableListView.getPackedPositionGroup(packedPosition);
				HFOnListGroupClickInterface listener = mListWidget.getOnGroupClickListener();
				if(listener != null) {
					listener.OnClick(mListWidget, listItem, groupPosition);
					mListWidget.notifyDataChanged();
				}
			}
		}
		//ȡǰviewĸ
		protected View getParent(View v) {
			View temp = v;
			View parent = (View) v.getParent();	
			while(parent != null) {
				if(parent.equals(mListWidget.getObject())) {
					return (View) temp;
				}
				temp = parent;
				parent = (View) parent.getParent();
			}
			
			return null;
		}
	}
	/** ÿϰť
	 * @param buttonWidget
	 * @return void
	 * @author LiangYJ
	 * @date 2015-7-7 10:28:03
	 */ 
	public void setTurnUpButton(HFBaseWidget buttonWidget){
		setTurnUpButton(buttonWidget,null);
	}
	/** ÿϰť
	 * @param buttonWidget
	 * @return void
	 * @author LiangYJ
	 * @date 2015-7-7 10:28:03
	 */ 
	public void setTurnUpButton(HFBaseWidget buttonWidget,HFOnTurnPageListener listener){
		mButtonWidgetTurnUp = buttonWidget;
		if(mButtonWidgetTurnUp != null)
			mButtonWidgetTurnUp.getObject().setOnClickListener(new TurnUpDownClickListerner(true));
		
		mOnTurnPageListener = listener;
		
	}
	
	/** ÿ°ť
	 * @param buttonWidget
	 * @return void
	 * @author LiangYJ
	 * @date 2015-7-7 10:27:49
	 */ 
	public void setTurnDownButton(HFBaseWidget buttonWidget){
		setTurnDownButton(buttonWidget, null);
	}
	
	/** ÿ°ť
	 * @param buttonWidget
	 * @param HFOnTurnPageListener
	 * @return void
	 * @author LiangYJ
	 * @date 2015-7-7 10:27:49
	 */ 
	public void setTurnDownButton(HFBaseWidget buttonWidget,HFOnTurnPageListener listener){
		mButtonWidgetTurnDown = buttonWidget;
		if(mButtonWidgetTurnDown != null)
			mButtonWidgetTurnDown.getObject().setOnClickListener(new TurnUpDownClickListerner(false));
		
		mOnTurnPageListener = listener;
	}
	
	/** ÷ҳ¼
	 * @param HFOnTurnPageListener
	 * @return void
	 * @author LiangYJ
	 * @date 2015-7-7 10:28:03
	 */ 
	public void setTurnPageListener(HFOnTurnPageListener listener){
		mOnTurnPageListener = listener;
	}
	
	/** һҳ
	 * 
	 * @return void
	 * @author LiangYJ
	 * @date 2015-7-7 10:29:37
	 */ 
	private void turnUp(){
//		Log.v("CLDLOG", "HFExpanableListWidget turnUp");
		stopTurnUpDown();
	    handler.postDelayed(run_turn_up, 0);
	}
	
	/** һҳ
	 * 
	 * @return void
	 * @author LiangYJ
	 * @date 2015-7-7 10:29:51
	 */ 
	private void turnDown(){
//		Log.v("CLDLOG", "HFExpanableListWidget turnDown");
		stopTurnUpDown();
	    handler.postDelayed(run_turn_down, 0);
	}
	
	private class TurnUpDownClickListerner implements OnClickListener{

		private boolean isTurnUp;
		public TurnUpDownClickListerner(boolean isTurnUp){
			this.isTurnUp = isTurnUp;
		}
		/**
		 * @see android.view.View.OnClickListener#onClick(android.view.View)
		 */
		@Override
		public void onClick(View v) {
			// TODO Auto-generated method stub
			if(isTurnUp)
				turnUp();
			else
				turnDown();
		}
		
	}
	
	private void setTurnUpButtonEnable(boolean enable){
		if(mButtonWidgetTurnUp != null)
			mButtonWidgetTurnUp.getObject().setEnabled(enable);
//		Log.v("CLDLOG", "turn up button enable:"+enable);
		//˵ײ
		if(mOnTurnPageListener != null && !enable)
			mOnTurnPageListener.scrolledToTop();
	}
	
	private void setTurnDownButtonEnable(boolean enable){
		if(mButtonWidgetTurnDown != null)
			mButtonWidgetTurnDown.getObject().setEnabled(enable);
//		Log.v("CLDLOG", "turn down button enable:"+enable);

		//˵ײ
		if(mOnTurnPageListener != null && !enable)
			mOnTurnPageListener.scrolledToBottom();
	}
	
	Handler handler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            handler.removeCallbacks(run_turn_down);
            handler.removeCallbacks(run_turn_up);
        }
    };
    
    /**
     * ֹͣ
     */
    public void stopTurnUpDown() {
        handler.removeCallbacks(run_turn_up);
        handler.removeCallbacks(run_turn_down);
    }
    Runnable run_turn_up = new Runnable() {
        @Override
        public void run() {
        	
        	HFExpandableListView listView = (HFExpandableListView)getObject();
        	
        	int count = listView.getChildCount();
        	if(count <= 0){
        		setTurnDownButtonEnable(false);
        		setTurnUpButtonEnable(false);
        	}
        	
        	View v = listView.getChildAt(0);  
			int top = (v == null) ? 0 : v.getTop();
        	if(top < 0 || (Math.abs(top) <= 10 && mFirstVisibleItem > 0)){
        		int height = listView.getBottom() - listView.getTop();
        		listView.smoothScrollBy(-height, 50);
        	}
        }
    };
    Runnable run_turn_down = new Runnable() {
        @Override
        public void run() {
        	
        	HFExpandableListView listView = (HFExpandableListView)getObject();
        	
        	int count = listView.getChildCount();
        	if(count <= 0){
        		setTurnDownButtonEnable(false);
        		setTurnUpButtonEnable(false);
        	}
        	int height = listView.getBottom() - listView.getTop();
        	if(!isLastRow){
        		listView.smoothScrollBy(height, 50);
        	}
        }
    };
    
    public interface HFOnTurnPageListener{
    	public void scrolledToBottom();
    	public void scrolledToTop();
    	public void scrolledToItem(int index);
    }
}
