package cnv.hf.widgets;

import java.util.ArrayList;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.StateListDrawable;
import cnv.hf.widgets.HFWidgetStorage.HFDrawableStorage;
import cnv.hf.widgets.HFWidgetStorage.HFImageItemStorage;
import cnv.hf.widgets.HFWidgetStorage.HFImageListStorage;

public class HFImageListWidget extends HFBaseWidget{

	private ArrayList<HFImageItem> tImages = null;
	private StateListDrawable statelist = null;
	public HFImageListWidget(Context context, Object widgetData) {
		super(context, widgetData);
		// TODO Auto-generated constructor stub
		initImageListMembers(widgetData);
	}
	
	@Override
	protected void setHolder(Context context,Object widgetData) {
		setObject(null);
	}
	//@Override
	private void initImageListMembers(Object widgetData) {

		HFImageListStorage data = (HFImageListStorage)widgetData;
		tImages = new ArrayList<HFImageItem>();
		statelist = new StateListDrawable();
		if(data != null) {
			int defaultResId = -1;
			HFImageItem itemClick = null;
			HFImageItem itemFocus = null;
			HFImageItemStorage imgItemClick = null;
			HFImageItemStorage imgItemFocus = null;
			for(int i = 0; i < data.getNumOfImages(); i++){
				HFImageItem item = new HFImageItem();
				HFImageItemStorage imgItem = data.getImageItem(i);
				item.setKey(imgItem.getlKey());
				HFDrawableWidget drawable = null;
				if(i == 0){//Ĭ
					defaultResId = imgItem.getDrawable().getBitmap();
					drawable = convertDynamicDrawable(imgItem.getDrawable());
				}else if(i == 1){//
//					drawable = convertDynamicDrawable(imgItem.getDrawable(),defaultResId);
					imgItemFocus = imgItem;
					itemFocus = item;
				}else if(i == 2){//
//					drawable = convertDynamicDrawable(imgItem.getDrawable(),clickResId);
					itemClick = item;
					imgItemClick = imgItem;
				}else{
					drawable = convertDynamicDrawable(imgItem.getDrawable());
				}
				
				item.setDrawable(drawable);
				tImages.add(item);
				
				
			}
			
			//
			if(imgItemFocus != null && imgItemClick != null && itemFocus != null && itemClick != null){
				int[] defaultIds = new int[2];
				defaultIds[1] = defaultResId;
				defaultIds[0] = imgItemFocus.getDrawable().getBitmap();
				
				//ֱý״̬״̬ı״̬ĻԴļǵĬͼƬ״̬ĻԴļǽĬͼƬ
				
				HFDrawableWidget drawable = convertDynamicDrawable(imgItemFocus.getDrawable(),defaultIds);
				itemFocus.setDrawable(drawable);

				defaultIds[0] = imgItemFocus.getDrawable().getBitmap();
				drawable = convertDynamicDrawable(imgItemClick.getDrawable(),defaultIds);
				itemClick.setDrawable(drawable);
			}
				
		}	
		setStateListDrawable();
	}
	/**
	 * ͼƬͼƬ
	 * 
	 * @param normald
	 * @param focusd
	 * @param clickd
	 * @param disabled
	 * @return void
	 * @author Dinghu
	 * @date 201569 10:06:28
	 */
	public void resetStateListDrawable(Drawable normald, Drawable focusd,
			Drawable clickd, Drawable disabled) {

		if (!(normald == null || focusd == null || clickd == null)) {
			statelist = null;
			statelist = new StateListDrawable();
			statelist.addState(new int[] { android.R.attr.state_focused },
					focusd);
			statelist.addState(new int[] { android.R.attr.state_pressed },
					clickd);
			statelist.addState(new int[] { android.R.attr.state_selected },
					clickd);
			if (disabled != null) {
				statelist.addState(new int[] { -android.R.attr.state_enabled },
						disabled);
			}
			statelist.addState(new int[] { android.R.attr.state_enabled },
					normald);
		}

	}
	public void setStateListDrawable(Drawable normald, Drawable focusd,
			Drawable clickd, Drawable disabled) {

		if (!(normald == null || focusd == null || clickd == null)) {
			statelist = null;
			statelist = new StateListDrawable();
			statelist.addState(new int[] { android.R.attr.state_focused },
					focusd);
			statelist.addState(new int[] { android.R.attr.state_pressed },
					clickd);
			statelist.addState(new int[] { android.R.attr.state_selected },
					clickd);
			if (disabled != null) {
				statelist.addState(new int[] { -android.R.attr.state_enabled },
						disabled);
			}
			statelist.addState(new int[] { android.R.attr.state_enabled },
					normald);
		}

	}
   private  void setStateListDrawable() {
		Drawable normald = null;
		Drawable focusd = null;
		Drawable clickd = null;
		Drawable disabled = null;
		if(tImages.size() > 0)
		  normald = getDrawable(tImages.get(0).getDrawable());
		if(tImages.size() > 1)
		  focusd = getDrawable(tImages.get(1).getDrawable());
		if(tImages.size() > 2)
		  clickd = getDrawable(tImages.get(2).getDrawable());
		if(tImages.size() > 3)
		  disabled = getDrawable(tImages.get(3).getDrawable());
		statelist = null;
		if(!(normald == null || focusd == null || clickd == null )) {
			statelist = new StateListDrawable(); 
			statelist.addState(new int[]{android.R.attr.state_focused}, focusd);  
			statelist.addState(new int[]{android.R.attr.state_pressed}, clickd);  
			statelist.addState(new int[] { android.R.attr.state_selected },
					focusd);
			if(disabled != null) {
				statelist.addState(new int[]{-android.R.attr.state_enabled}, disabled);
			}
			statelist.addState(new int[]{android.R.attr.state_enabled}, normald);  
		}
	}
	
	public Drawable getImageListDrawable(){
		return statelist;
	}
	
	public class HFImageItem{
		private int					lKey;         //Ψһ־
		private HFDrawableWidget    tDrawable;    //ҪͼƬ
		
		public int getKey() {
			return lKey;
		}
		public void setKey(int lKey) {
			this.lKey = lKey;
		}
		public HFDrawableWidget getDrawable() {
			return tDrawable;
		}
		public void setDrawable(HFDrawableWidget tDrawable) {
			this.tDrawable = tDrawable;
		}
	}
	
	/*======================================================
	: ȡͼƬĸ
	: 
	ֵ: ͼƬĸ
	======================================================*/
	public int getNumOfImages(){
		return tImages.size();
	}
	
	/*======================================================
	: ȡͼƬ
	:  widget           [in] ؼָ
	       in_lIndex		[in] ͼƬ

	ֵ: =0: ɹ;>0: 
	======================================================*/
	public HFDrawableWidget getImageByIndex(int lIndex){
		if(lIndex >= 0 && lIndex < tImages.size())
			return tImages.get(lIndex).getDrawable();
		return null;
	}
	
	/*======================================================
	: ȡͼƬ
	:  widget           [in] ؼָ
	       in_lIndex		[in] ͼƬ
		   out_pImage		[out] ͼƬ

	ֵ: =0: ɹ;>0: 
	======================================================*/
	public HFDrawableWidget getImageByKey(int in_lKey){
		for(int i = 0; i < tImages.size(); i++){
			if(tImages.get(i).getKey() == in_lKey)
				return tImages.get(i).getDrawable();
		}
		return null;
	}
	
	/*======================================================
	: ȡͼƬ
	:  widget           [in] ؼָ
	       in_lIndex		[in] ͼƬ
		   in_pDrawable		[in] ͼƬ

	ֵ: =0: ɹ;>0: 
	======================================================*/
	public void setImageByKey(int in_lKey,HFDrawableWidget in_pDrawable){
		for(int i = 0; i < tImages.size(); i++){
			if(tImages.get(i).getKey() == in_lKey)
			{
			  tImages.get(i).setDrawable(in_pDrawable);
			  setStateListDrawable();
			  break;
			}
		}
	}

}
