package cnv.hf.widgets;

import java.util.ArrayList;

import android.content.Context;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;
import cnv.hf.widgets.HFWidgetStorage.HFListItemStorage;
import cnv.hf.widgets.HFWidgetStorage.HFListStorage;

public class HFListWidget extends HFBaseWidget {
	private short	gapOfItems;		/*бƫ*/				
	private int 	listStyle;		/*бķ*/	
	private HFDelegateWidget mDelegate = null;
	private HFAdapterWidget mAdapter = null;
	private ArrayList<HFListItem> listItems = null;
	//бص
	private HFOnListItemClickInterface mOnItemClickListener = null;
	
	public HFListWidget(Context context, Object widgetData) {
		super(context, widgetData);
		listItems = new ArrayList<HFListItem>();
		initListMembers(widgetData);
		mDelegate = new HFDelegateWidget(this);
		((ListView)getObject()).setAdapter(mDelegate);		
	}
	
	@Override
	protected void setHolder(Context context,Object widgetData) {
		setObject(new ListView(context));
	}
	
	private void initListMembers(Object widgetData) {
		HFListStorage btnData = (HFListStorage)widgetData;
		if(btnData != null) {
			int index;
			setListStyle(btnData.getListStyle());
			for(index =0 ; index < btnData.getNumOfListItems(); index++) {
				addItem(new HFListItem(getObject().getContext(), btnData.getItem(index)));
			}
		}
	}
	public short getGapOfItems() {
		return gapOfItems;
	}

	public void setGapOfItems(short gapOfItems) {
		this.gapOfItems = gapOfItems;
	}

	public int getListStyle() {
		return listStyle;
	}

	public void setListStyle(int listStyle) {
		this.listStyle = listStyle;
	}
	
	protected int getNumOfListItems() {
		return listItems.size();
	}

	public void addItem(HFListItem item) {
		listItems.add(item);
	}
	
	protected HFListItem getItem(int index) {
		return listItems.get(index);
	}
	
	public HFAdapterWidget getAdapter() {
		return mAdapter;
	}

	public void setAdapter(HFAdapterWidget adapter) {
		this.mAdapter = adapter;
	}
	/*======================================================
	: ȡбĻص
	:  
	ֵ: ص
	======================================================*/	
	public HFOnListItemClickInterface getOnItemClickListener() {
		return mOnItemClickListener;
	}
	/*======================================================
	: бĻص
	: in_pListener     [in] ص
	ֵ: =0 ɹ >0 
	======================================================*/
	public void setOnItemClickListener(HFOnListItemClickInterface onItemClickListener) {
		mOnItemClickListener = onItemClickListener;
		if(getObject() != null) {
			((ListView)getObject()).setOnItemClickListener(mOnListItemClickListener);
		}		
	}
	
	//ػListؼ¼ɷԶؼ
	private OnItemClickListener mOnListItemClickListener = new OnItemClickListener() {

		@Override
		public void onItemClick(AdapterView<?> arg0, View arg1, int arg2,
				long arg3) {
			
			HFListWidget listWidget = null;
			HFModeWidget modeWidget = (HFModeWidget) arg0.getContext();
			if(arg0 != null) {
				listWidget = (HFListWidget) modeWidget.findWidgetByObject(arg0);
			}
			if(mOnItemClickListener != null) {
				mOnItemClickListener.OnClick(listWidget, (HFLayerWidget)arg1, arg2);
			}
		}
	};
	/*======================================================
	: ִбĵ¼
	: listItem     [in] б
	ֵ: false δִУtrue ִ
	======================================================*/
	protected boolean performItemClick(HFLayerWidget listItem) {
		if(listItem != null && mOnItemClickListener != null) {
			ListView listView = (ListView)getObject();
			if(listView != null) {
				int position = listView.indexOfChild(listItem);
				mOnItemClickListener.OnClick(this, (HFLayerWidget)listItem, position);
				return true;
			}
		}
		return false;
	}
	//б
	public class HFListStyle 	{
	    public static final int eListStyle_Normal    			= 0x00000001; //ͨб
	    public static final int eListStyle_Feature   			= 0x00000002; //б̶
	    public static final int eListStyle_NormalPreferences   	= 0x00000003; //Բͨб(iPhone)
	    public static final int eListStyle_FeaturePreferences  	= 0x00000004; //Բǹб(iPhone)
	}
	//ӿ
	public interface HFAdapterWidget {
		public int getItemCount(); //ȡݸ
		public View getItemData(int index, View listItem);
	}
	/*======================================================
	:  ؼ¼Ӧ
	:  parent         [in]  ؼ(ָlistؼ)
	       sender         [in]  Ŀؼ
	       position       [in]  
	ֵ:FALSE: ¼δ; 
	       TRUE:¼Ѵ
	======================================================*/
	//ӿ
	public interface HFOnListItemClickInterface {
		public void OnClick(HFBaseWidget parent, HFLayerWidget sender, int position);
	}
	
	public class HFListItem extends HFButtonWidget{
		private HFLayerWidget layerWidget = null;
		private int listItemType;
		
		public HFListItem(Context context, Object widgetData) {
			super(context, widgetData);
			// TODO Auto-generated constructor stub
			//бĬ
			setListItemType(HFListItemType.eListItemType_Normal);
			//б
			initListItemMembers(widgetData);
		}
		private void initListItemMembers(Object widgetData) {
			HFListItemStorage btnData = (HFListItemStorage)widgetData;
			if(btnData != null) {
				//б
				setListItemType(btnData.getItemType());
				//ͼб
				setLayerWidget(findLayerById(btnData.getLayerId()));		
			}
		}
		/*======================================================
		: ͨͼIdȡͼ
		:  
				Id   [in] ͼId
		
		ֵ: ͼ
		======================================================*/
		private HFLayerWidget findLayerById(int layerId) {
		
			HFModeWidget modeWidget = (HFModeWidget)(getObject().getContext());
			if(modeWidget != null) {
				return modeWidget.findLayerById(layerId);
			}
			return null;
		}
		public HFLayerWidget getLayerWidget() {
			return layerWidget;
		}
		public void setLayerWidget(HFLayerWidget layerWidget) {
			this.layerWidget = layerWidget;
		}
		public int getListItemType() {
			return listItemType;
		}
		public void setListItemType(int listItemType) {
			this.listItemType = listItemType;
		}
		//б
		public class	HFListItemType {
		    public static final	int eListItemType_Normal    = 0x00000001;   //
		    public static final int eListItemType_Divider   = 0x00000002;   //ָ
		    public static final int eListItemType_Header = 0x00000003;      //бͷ
		    public static final int eListItemType_Footor = 0x00000004;      //б
		}
		
		public class HFListItemTypeExt
		{
		    //don't show any accessory view
			public static final	int eListItemTypeExt_None = 0x00000001;
		    // regular chevron. doesn't track
		    public static final	int eListItemTypeExt_DisclosureIndicator = 0x00000002;
		    //blue button w/ chevron. tracks
			public static final	int eListItemTypeExt_DetailDisclosureButton = 0x00000003;
		    // checkmark. doesn't track
			public static final	int eListItemTypeExt_Checkmark = 0x00000004;
		    //
			public static final	int inteListItemTypeExt_Pull = 0x00000005;
		}
	}
}
