package cnv.hf.widgets;

import hmi.packages.HPAppEnv;
import hmi.packages.HPSysEnv;
import hmi.packages.HPWidgetEvent;
import hmi.packages.HPWindowManager;
import hmi.packages.HPWidgetEvent.HPWidgetEventArgument;
import hmi.packages.HPWidgetEvent.HPWidgetEventType;
import hmi.packages.HPWidgetEvent.HPWidgetKeyArgument;
import hmi.packages.HPWidgetEvent.HPWidgetKeyEvent;

import java.util.ArrayList;

import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.res.Configuration;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.Rect;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.StateListDrawable;
import android.media.AudioManager;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v4.app.FragmentActivity;
import android.util.DisplayMetrics;
import android.view.Display;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewTreeObserver.OnGlobalLayoutListener;
import android.view.Window;
import android.view.WindowManager;
import android.widget.AbsoluteLayout;
import android.widget.AbsoluteLayout.LayoutParams;
import android.widget.AdapterView;
import android.widget.Button;
import cnv.hf.widgets.HFCustomAbsoluteLayout.HFICustomAbsoluteListener;
import cnv.hf.widgets.HFModesManager.HFOnChangeOrientationInterface;
import cnv.hf.widgets.HFModesManager.HFOrientation;
import cnv.hf.widgets.HFModesManager.HFPendingTransition;
import cnv.hf.widgets.HFWidgetStorage.HFLayerStorage;
import cnv.hf.widgets.HFWidgetStorage.HFModeStorage;
import cnv.hf.widgets.HFWidgetsManager.HFWidgetType;

@SuppressWarnings("deprecation")
public abstract class HFModeActivity extends FragmentActivity implements HFModeWidget {
	//ģʽͼ
	private AbsoluteLayout mScrollView = null;
	//Activity
	private HFCustomAbsoluteLayout mContentView = null;
	//˵
	private HFSlideMenu mSlideMenu = null;
	private ArrayList<HFLayerWidget> mLayers = null;
	private ArrayList<HFRadioButtonWidget> mRadioButtons = null;
	private HPWidgetEventArgument mEventArgs = null;
	private HFWorkHandler mWorkHandler = null;
	private HFOnMessageInterface mOnMessageListener = null;
	private HFModeStorage mModeData = null;
	//X᷽
	private float mXScaleFactor = 1.0f;
	//Y᷽
	private float mYScaleFactor = 1.0f; 
	//ĬϴģʽĶΪңرģʽʱҵ
	private int mPendingTransition = HFPendingTransition.ePendingTransition_LeftRight;
	//ǰģʽĺ汾
	private int mOrientation = 0;
	//ǰSysEnv
	public HPSysEnv sysEnv = null;
	//˵滻Id
	public final static int HF_MENU_CONTENT_ID = 2013091215;
	//ViewڼڴСı
	private View mWindowView = null;
    //ͼActivityǰ״̬
	private int mModeActivityState = HFModeActivityState.ActivityState_None;
	
	//added by LiangYJ 20150729
	private HFAnalyticsStorage mAnalyticsStorage;
	//end
	//ǷԶõͼؼСĬtrueȫֻлⰴԶ
	private boolean autoResetMapviewSize = true;
	//ͼСautoResetMapviewSize=falseûãshoulResetMapviewSizeΪtrue
	private boolean shouldResetMapviewSize = false;
	
	public static class HFModeActivityState{
		public static int ActivityState_None = 0;
		public static int ActivityState_OnCreate = 1;
		public static int ActivityState_onRestart = 2;
		public static int ActivityState_onOnStart = 3;
		public static int ActivityState_onOnResume = 4;
		public static int ActivityState_onOnPause = 5;
		public static int ActivityState_onOnStop = 6;
		public static int ActivityState_onOnDestroy = 7;
	}
	//ǰģʽǷŻͼ㼰ؼķʽ
	private boolean mIsOptimized = false;
	//ģʽ
	private HFModeLoader mModeLoader = null;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
		doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Create_Begin);
        super.onCreate(savedInstanceState);
        sysEnv = getSysEnv();
    	//ʼ
    	initRequestArgs();
    	
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		//ģʽ桡
		setOrientation(HFModesManager.getOrientation());
		//ģʽ
		setPendingTransition(HFModesManager.getTempTransition());
		//Ƿȫ
		if(HFModesManager.isFullScreen()) {
			getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
					WindowManager.LayoutParams.FLAG_FULLSCREEN);
		}
		mModeData = new HFModeStorage();
		//ģʽջ
		HFModesManager.pushMode(this);
		//scrollView
        //mScrollView = new ScrollView(this);
		mScrollView = new AbsoluteLayout(this);
		mContentView = new HFCustomAbsoluteLayout(this);
		mContentView.setLayoutListener(new HFICustomAbsoluteListener() {
			
			@Override
			public void onLayoutChanged(int l, int t, int r, int b) {
				if(r > 0 && b > 0 && r > l && b > t){
					if (Build.VERSION.SDK_INT >= 24
							&& Build.MANUFACTURER.equalsIgnoreCase("OPPO")
							&& getContext().getResources().getConfiguration().orientation == Configuration.ORIENTATION_LANDSCAPE
							&& (!HFModesManager.resetLayoutOnCurrentMode && Math
									.abs(System.currentTimeMillis()
											- HFModesManager.lastEditTouchTime) < 500)) {
						return;
					}
					HFModesManager.setScreenPixels(r - l, b - t + HFModesManager.getStatusBarHeight());
					if (Build.VERSION.SDK_INT >= 24
							&& Build.MANUFACTURER.equalsIgnoreCase("OPPO")) {
						if (HFModesManager.resetLayoutOnCurrentMode
								|| (!HFModesManager.resetLayoutOnCurrentMode && Math
										.abs(System.currentTimeMillis()
												- HFModesManager.lastEditTouchTime) > 500)) {
							beforeResetLayout();
							reloadLayout(null, false);
							resetMapView(r - l, b - t);
						}else{
							HFModesManager.shouldResetScreenOnFrameCreate = true;
						}
						HFModesManager.resetLayoutOnCurrentMode = true;
					} else {
						beforeResetLayout();
						reloadLayout(null, false);
						resetMapView(r - l, b - t);
					}
					
				}
			}
		});
		mContentView.setId(2013121816);
		//˵
		mSlideMenu = new HFSlideMenu(this);
        //ͼ
        mLayers = new ArrayList<HFLayerWidget>();
        //RadioButton
        mRadioButtons = new ArrayList<HFRadioButtonWidget>();
        //óʼǰ
        onBeforeInit();
        //װͼͼ
        loadLayerWidgets();
        //Ҫʾͼ
        //addLayerWidget2Display(0);
        //mScrollViewõģʽʾ
        HFLayerWidget layerMenu = new HFLayerWidget(this);
        layerMenu.setId(HF_MENU_CONTENT_ID);
        //added by LiangYJ 20151125
        //ʾmenu
        layerMenu.setBound(new HFWidgetBound(0, 0, 0, 500));
        Button mButton = new Button(this);
        mButton.setLayoutParams(new LayoutParams(0,200,0,0));
        //end
        mButton.setBackgroundDrawable(null);
        layerMenu.addView(mButton);
        mSlideMenu.setMenu(layerMenu);
        mSlideMenu.setContent(mScrollView);
        mContentView.addView(mSlideMenu);
       // mContentView.setKeepScreenOn(true);
        setContentView(mContentView);
        //óʼ
        onInit();
        //STREAM_MUSICTTS
        setVolumeControlStream(AudioManager.STREAM_MUSIC);
        //ôڴСı
        //setWindowSizeChangeListener();
        //Acitity״̬
        setModeActivityState(HFModeActivityState.ActivityState_OnCreate);
        doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Create_Finish);
	}
	protected void unbindDrawables(View view) {  
	    if (view.getBackground() != null) { 
	    	Drawable bg = view.getBackground();
	    	if(bg instanceof BitmapDrawable) {
	    		BitmapDrawable bd = (BitmapDrawable) bg;
	    		Bitmap bm = bd.getBitmap();
	    		if( bm != null && !bm.isRecycled()) {
	    			bm.recycle();
	    		}
	    	}
	    	else
	    	if(bg instanceof StateListDrawable) {
	    		StateListDrawable sd = (StateListDrawable) bg;
	    		sd.setCallback(null);
	    	}
	        view.getBackground().setCallback(null);
	    	view.setBackgroundResource(0);
	        view = null;
	    }  
	    if (view instanceof ViewGroup) {  
	        for (int i = 0; i < ((ViewGroup) view).getChildCount(); i++) {  
	            unbindDrawables(((ViewGroup) view).getChildAt(i));  
	        }  
	        if(!(view instanceof AdapterView)) {
	        	((ViewGroup) view).removeAllViews();
	        }
	    }  
	}
    
	@Override
	protected void onDestroy() {
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Destroy_Begin);
		//رģʽװ
		closeModeLoader(null);
		//ùرպ
		onClose();		
		HFModesManager.popMode(this);
		//unbindDrawables(mScrollView);
		//System.gc(); 
		//ɾڴСı
		//moveWindowSizeChangeListener();
		 //ÿɵ״̬
		super.onDestroy();
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Destroy_Finish);
	}
	abstract protected String getModeName();	
	/*======================================================
	: ȡģʽװ
	:  
	
	ֵ: ģʽװ
	======================================================*/
	 public HFModeLoader getModeLoader() {
		if(mModeLoader == null) {
			mModeLoader = new HFModeLoader();
			String fileName = HFModesManager.getLaoutsPath() + getModeName();
			if(0 == mModeLoader.loadMode(fileName)) {
				return mModeLoader;
			}
			mModeLoader = null;
		}
        return mModeLoader;        
	 }
	/*======================================================
	: رģʽװ
	:  
	
	ֵ: 
	======================================================*/
	 public void closeModeLoader(HFModeLoader modeLoader) {
		 if(isOptimized() && modeLoader != null)
			 return ;
		 if(mModeLoader != null) {
			 mModeLoader.close();
		 }
		 mModeLoader = null;
	 }
	/*======================================================
	: ͼݴͼ
	:	modeLoader [in] ģʽ
			layerData  [in] ͼ
	ֵ: ͼ
	======================================================*/
	 public HFLayerWidget createLayerWidgets(HFModeLoader modeLoader, 
			 									HFLayerStorage layerData) {
		 
		 //HFWidgetPoint deltaXY = new HFWidgetPoint();
		//
		// scaleLayerCoords(layerData.getBound(), deltaXY);
		 scaleCoords(layerData.getBound(),0);
		 HFWidgetsManager widgetsMan = new HFWidgetsManager(this);
		 HFLayerWidget layer =(HFLayerWidget)widgetsMan.createWidget(	HFWidgetType.eWidgetType_Layer, 
				 														layerData);
		 if(layer != null && !layerData.isOptimized()) {
			 layer.loadWidgets(this, modeLoader);
		 }
		 return layer;
	 }
		 
		 /*======================================================
			: ͼݴͼ
			:	
			        modeLoader [in] ģʽ
					layerId  [in] ͼ
					
			ֵ: ͼ
			======================================================*/
		public HFLayerWidget createLayerWidgets(HFModeLoader modeLoader,int layerId) {
			HFLayerWidget layer = null; 
			if(layerId >  0) {
		        if(modeLoader != null) {
			        int numLayers = modeLoader.getNumOfLayers();
			    	for(int index = 0; index < numLayers; index++) {
			        	HFLayerStorage playerData = new HFLayerStorage();
			    		if(0 == modeLoader.getLayerData(index, playerData)) {
							if(playerData.getId() == layerId) {
								layer = createLayerWidgets(modeLoader, playerData);
								break;
							}
			    		}
			    	}
		        }
			}
	    	if(layer == null) {
	    		HFWidgetsManager widgetsMan = new HFWidgetsManager(this);
	    		layer =(HFLayerWidget)widgetsMan.createWidget(HFWidgetType.eWidgetType_Layer, null);
	    	}
			return layer;
	}	 
	 
	/*======================================================
	: ͼݴͼ
	:	
			layerId  [in] ͼ
			
	ֵ: ͼ
	======================================================*/
	 public HFLayerWidget createLayerWidgets(int layerId) {
//		HFLayerWidget layer = null; 
//		if(layerId >  0) {
//	    	HFModeLoader modeLoader = getModeLoader();
//	        if(modeLoader != null) {
//		        int numLayers = modeLoader.getNumOfLayers();
//		    	for(int index = 0; index < numLayers; index++) {
//		        	HFLayerStorage playerData = new HFLayerStorage();
//		    		if(0 == modeLoader.getLayerData(index, playerData)) {
//						if(playerData.getId() == layerId) {
//							layer = createLayerWidgets(modeLoader, playerData);
//							break;
//						}
//		    		}
//		    	}
//		    	closeModeLoader(modeLoader);
//	        }
//		}
//    	if(layer == null) {
//    		HFWidgetsManager widgetsMan = new HFWidgetsManager(this);
//    		layer =(HFLayerWidget)widgetsMan.createWidget(HFWidgetType.eWidgetType_Layer, null);
//    	}
//		return layer;
		return createLayerWidgets(layerId,true);
	 }	 
	 
	 /*======================================================
		: ͼݴͼ
		:	
				layerId  [in] ͼ
				
		ֵ: ͼ
		======================================================*/
		 public HFLayerWidget createLayerWidgets(int layerId, boolean closeModeLoader) {
			HFLayerWidget layer = null; 
			if(layerId >  0) {
		    	HFModeLoader modeLoader = getModeLoader();
		        if(modeLoader != null) {
			        int numLayers = modeLoader.getNumOfLayers();
			    	for(int index = 0; index < numLayers; index++) {
			        	HFLayerStorage playerData = new HFLayerStorage();
			    		if(0 == modeLoader.getLayerData(index, playerData)) {
							if(playerData.getId() == layerId) {
								layer = createLayerWidgets(modeLoader, playerData);
								break;
							}
			    		}
			    	}
			    	if(closeModeLoader)
			    	    closeModeLoader(modeLoader);
		        }
			}
	    	if(layer == null) {
	    		HFWidgetsManager widgetsMan = new HFWidgetsManager(this);
	    		layer =(HFLayerWidget)widgetsMan.createWidget(HFWidgetType.eWidgetType_Layer, null);
	    	}
			return layer;
		 }	 
	/*======================================================
	: װͼ
	:  
	
	ֵ: 
	======================================================*/
	public void loadLayerWidgets() {
		
        HFLayerWidget pLayer = null;
    	HFModeLoader modeLoader = getModeLoader();
        if(modeLoader == null) {
        	return ;
        }	
        boolean isFirst = true;
    	//װģʽ
    	modeLoader.getModeData(mModeData);
    	//
    	calcScaleFactor();
    	int numLayers = modeLoader.getNumOfLayers();
    	for(int i = 0; i < numLayers; i++) {
        	HFLayerStorage playerData = new HFLayerStorage();
    		if(0 == modeLoader.getLayerData(i, playerData)) {
    			if(playerData.getParent() <= 0) {
					//
					//scaleCoords(playerData.getBound());
					//scaleLayerCoords(playerData.getBound());
    				//Żؿؼʽһͼ(ͼ)Ҳȫװ
    				playerData.setIsOptimized((isOptimized() && !isFirst));    				
    				pLayer = createLayerWidgets(modeLoader, playerData); 
    				addLayerWidget2Display(pLayer);
    				isFirst = false;
    			}			
    		}
    	}
    	closeModeLoader(modeLoader);
	}	 
	/*======================================================
	: ͨӿؼIdȡӿؼ
	:  
			id  [in] ӿؼId
	
	ֵ: ӿؼ
	======================================================*/
	public HFBaseWidget findWidgetById(int id) {
		if(mLayers != null){
			synchronized(mLayers)
			{
				HFBaseWidget widget = null;
				HFLayerWidget pLayer = null;
				
				for(int index = 0; index < mLayers.size(); index++) {
					pLayer = (HFLayerWidget) mLayers.get(index);
					if(pLayer != null) {
						widget = pLayer.findWidgetById(id);
						if(widget != null) {
							return widget;
						}
					}
				}
			}
		}
		return null;
	}	
	/*======================================================
	: ͨӿؼƻȡӿؼ
	:  
			in_cWidgetName   [in] ӿؼ
	
	ֵ: ӿؼ
	======================================================*/
	public HFBaseWidget findWidgetByName(String widgetName) {
		if(mLayers != null){
			synchronized(mLayers)
			{
				HFBaseWidget widget = null;
				HFLayerWidget pLayer = null;
				
				for(int index = 0; index < mLayers.size(); index++) {
					pLayer = (HFLayerWidget) mLayers.get(index);
					if(pLayer != null) {
						widget = pLayer.findWidgetByName(widgetName);
						if(widget != null) {
							return widget;
						}
					}
				}
			}
		}
		return null;
	}
	/*======================================================
	: ͨӿؼƻȡӿؼ
	:  
			in_cWidgetName   [in] ӿؼ
	
	ֵ: ӿؼ
	======================================================*/
	public HFBaseWidget findWidgetByObject(Object widget) {
		
		HFBaseWidget base = null;
		HFLayerWidget pLayer = null;
		
		for(int index = 0; index < mLayers.size(); index++) {
			pLayer = (HFLayerWidget) mLayers.get(index);
			if(pLayer != null) {
				base = pLayer.findWidgetByObject(widget);
				if(base != null) {
					return base;
				}
			}
		}
		return null;
	}	
	/*======================================================
	: ͨͼȡͼ
	:  
			index   [in] ͼ
	
	ֵ: ͼ
	======================================================*/
	public HFLayerWidget getLayerByIndex(int index) {
		
		if(index >= 0 && index < mLayers.size()) {
			return (HFLayerWidget) mLayers.get(index);
		}
		return null;
	}
	/*======================================================
	: ͨͼIdȡͼ
	:  
			Id   [in] ͼId
	
	ֵ: ͼ
	======================================================*/
	public HFLayerWidget findLayerById(int layerId) {

		HFLayerWidget pLayer = null;
		
		for(int index = 0; index < mLayers.size(); index++) {
			pLayer = (HFLayerWidget) mLayers.get(index);
			if(pLayer != null && pLayer.getWidgetId() == layerId) {
				return pLayer;
			}
		}
		return null;
	}	
	/*======================================================
	: ͨͼƻȡͼ
	:  
			Id   [in] ͼId
	
	ֵ: ͼ
	======================================================*/
	public HFLayerWidget findLayerByName(String layerName) {

		HFLayerWidget pLayer = null;
		
		for(int index = 0; index < mLayers.size(); index++) {
			pLayer = (HFLayerWidget) mLayers.get(index);
			if(pLayer != null && pLayer.getName().equalsIgnoreCase(layerName)) {
				return pLayer;
			}
		}
		return null;
	}	
	/*======================================================
	: һͼлһͼ
	:  
			fromLayer   [in] лͼ 
			toLayer     [in] Ҫлͼ
	
	ֵ: ͼ
	======================================================*/
	public void switchLayerWidget(String fromLayer, String toLayer) {
		
		HFLayerWidget sourcelayer = findLayerByName(fromLayer);
		HFLayerWidget destLayer = findLayerByName(toLayer);
		if(sourcelayer != null) {
			mScrollView.removeView(sourcelayer);
		}
		if(destLayer != null) {
			mScrollView.addView(destLayer);
		}
	}
	/*======================================================
	: һͼģʽϣʾ
	:  
			layerWidget   [in] Ҫӵͼ 

	ֵ: 
	======================================================*/
	public void addLayerWidget(HFLayerWidget layerWidget) {
		
		if(layerWidget != null) {
			mLayers.add(layerWidget);
		}
	}
	
	/*======================================================
	: ɾһͼģʽ
	:  
			layerWidget   [in] Ҫɾͼ 

	ֵ: 
	======================================================*/
	public void removeLayerWidget(HFLayerWidget layerWidget){
		if(layerWidget != null) {
			mLayers.remove(layerWidget);
		}
	}
	
	/*======================================================
	: һͼ±
	:  
			layerName  [in] ͼ

	ֵ: index
	======================================================*/
	public int getLayerWidgetIndex(String layerName){
        HFLayerWidget pLayer = null;
		for(int index = 0; index < mLayers.size(); index++) {
			pLayer = (HFLayerWidget) mLayers.get(index);
			if(pLayer != null && pLayer.getName().equalsIgnoreCase(layerName)) {
				return index;
			}
		}
		return -1;
	}
	
	/*======================================================
	: һͼʾĵ±
	:  
			layerName  [in] ͼ

	ֵ: index
	======================================================*/
	public int getLayerWidgetIndexFromDisplay(String layerName){
		 HFLayerWidget pLayer = null;
		 for(int index = 0; index < mScrollView.getChildCount(); index++) {
				pLayer = (HFLayerWidget) mScrollView.getChildAt(index);
				if(pLayer != null && pLayer.getName().equalsIgnoreCase(layerName)) {
					return index;
				}
			}
			return -1;
	}
	
	/*======================================================
	: һͼʾ
	:  
			layerName   [in] Ҫʾͼ 

	ֵ: 
	======================================================*/
	public void addLayerWidget2Display(HFLayerWidget layerWidget) {
		
		if(layerWidget != null) {
			mLayers.add(layerWidget);
			HFWidgetBound bound = layerWidget.getBound();
			if(bound != null) {
				LayoutParams params = new LayoutParams(	bound.getWidth(), bound.getHeight(),
														bound.getLeft(), bound.getTop());
				mScrollView.addView(layerWidget, params);
			}
			else {
				mScrollView.addView(layerWidget);
			}
		}
	}
	
	/*======================================================
	: һͼʾ
	:  
			layerWidget   [in] Ҫʾͼ 
             index        [in] ±
	ֵ: 
	======================================================*/
	public void addLayerWidget2Display(HFLayerWidget layerWidget,int index){
		if(layerWidget != null) {
			mLayers.add(layerWidget);
			HFWidgetBound bound = layerWidget.getBound();
			if(bound != null) {
				LayoutParams params = new LayoutParams(	bound.getWidth(), bound.getHeight(),
														bound.getLeft(), bound.getTop());
				mScrollView.addView(layerWidget,index,params);
			}
			else {
				mScrollView.addView(layerWidget,index);
			}
		}
	}
	
	/*======================================================
	: һͼʾ
	:  
			layerName   [in] Ҫʾͼ 

	ֵ: 
	======================================================*/
	public void addLayerWidget2Display(String layerName) {
		HFLayerWidget layerWidget = findLayerByName(layerName);
		addLayerWidget2Display(layerWidget);
	}
	/*======================================================
	: һͼʾ
	:  
			layerIndex   [in] Ҫʾͼ 

	ֵ: 
	======================================================*/
	public void addLayerWidget2Display(int index) {
		HFLayerWidget layerWidget = getLayerByIndex(index);
		if(layerWidget != null) {
			mScrollView.addView(layerWidget);
		}
	}	
	/*======================================================
	: ʾƳһʾ
	:  
			layerName   [in] Ҫʾͼ 

	ֵ: 
	======================================================*/
	public void removeLayerWidgetFromDisplay(String layerName) {
		HFLayerWidget layerWidget = findLayerByName(layerName);
		if(layerWidget != null) {
			mScrollView.removeView(layerWidget);
		}
	}
	public void removeLayerWidgetFromDisplay(HFLayerWidget layerWidget) {
		if(layerWidget != null) {
			mScrollView.removeView(layerWidget);
		}
	}
	public String getName() {
		if(mModeData != null && mModeData.getModeName() != null)
		    return mModeData.getModeName();
	    return "";
	}
	protected void setName(String widgetName) {
		mModeData.setModeName(widgetName);
	}
	/*=======================================================
	: ȡؼId
	: 
	ֵ: ؼId
	======================================================*/	
	public int getModeId() {
		return mModeData.getModeId();
	}
	/*=======================================================
	: ÿؼId
	: id [in] ؼId
	ֵ: 
	======================================================*/
	public void setModeId(int id) {
		mModeData.setModeId(id);
	}	
	/*======================================================
	: ͨGroupIdRadioButton
	:  groupid       [in] RadioButtonGroupId
	ֵ: еλ
	======================================================*/
	protected int findRadioButton(int groupId) {
		
		HFRadioButtonWidget radioButton = null;
		
		for(int index = 0; index < mRadioButtons.size(); index++) {
			radioButton = mRadioButtons.get(index);
			if(radioButton != null && radioButton.getGroupId() == groupId) {
				return index;
			}
		}
		return -1;
	}
	/*======================================================
	: ñѡеRadioButton
	:  in_pRadioButton   [in] ѡеRadioButton
	ֵ: =0:ɹ>0 
	======================================================*/
	public void setRadioButton(HFRadioButtonWidget radioButton) {
		if(radioButton == null) {
			return ;
		}
		int index = findRadioButton(radioButton.getGroupId());
		if(index == -1) {
			mRadioButtons.add(radioButton);
		} 
		else {
			HFRadioButtonWidget priorRadioButton = mRadioButtons.get(index);
			if(priorRadioButton != radioButton) {
				priorRadioButton.setChecked(false);
				mRadioButtons.remove(index);
				mRadioButtons.add(radioButton);
			}
		}
	}
	//activityonResume
	@Override
	protected void onResume() {
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Resume_Begin);
		super.onResume();	
		//OnUpdateص
		onUpdate();		
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Resume_Finish);
	}
	@Override
	protected void onPause() {
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Pause_Begin);
		super.onPause();
		//رģʽװ
		closeModeLoader(null);
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Pause_Finish);
	}	
	//activityonRestart
	@Override
	protected void onRestart() {
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_ReStart_Begin);
		//Ļʱб䶯,Ҫ
		HFOnChangeOrientationInterface listener = HFModesManager.getOnChangeOrientationListener();
		if(listener != null) {
			int orientation = this.getOrientation();
			if(listener.OnChangeOrentation(this, orientation)) {
				changeOrientation(orientation);
			}
		}
		//onReEnter
		onReEnter();	
		//drawable
		reloadDrawable();
		super.onRestart();
    	doAnalytics(HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_ReStart_Finish);
	}
	//activityKeyup
	@Override
	public boolean onKeyUp (int keyCode, KeyEvent event) {
		
		HPWidgetEventArgument eventArgs = getEventArgs();
		eventArgs.eventType = (HPWidgetEventType.eWidgetEventType_Key);
		eventArgs.eventSubtype = (HPWidgetKeyEvent.eWidgetKeyEvent_Up);
		HPWidgetKeyArgument keyArgs = (HPWidgetKeyArgument) eventArgs.obtainEventArgs(HPWidgetEventType.eWidgetEventType_Key, 
																HPWidgetKeyEvent.eWidgetKeyEvent_Up);
		keyArgs.keyCode = (keyCode);
		keyArgs.keyStatus = (event.getFlags());
		if(onMessageProc(eventArgs))
			return true;
		return super.onKeyUp(keyCode, event);
	}
	//activityKeydown
	@Override
	public boolean onKeyDown (int keyCode, KeyEvent event) {
		
		HPWidgetEventArgument eventArgs = getEventArgs();
		eventArgs.eventType = (HPWidgetEventType.eWidgetEventType_Key);
		eventArgs.eventSubtype = (HPWidgetKeyEvent.eWidgetKeyEvent_Down);
		HPWidgetKeyArgument keyArgs = (HPWidgetKeyArgument) eventArgs.obtainEventArgs(HPWidgetEventType.eWidgetEventType_Key, 
																HPWidgetKeyEvent.eWidgetKeyEvent_Down);
		keyArgs.keyCode = (keyCode);
		keyArgs.keyStatus = (event.getFlags());
		if(onMessageProc(eventArgs))
			return true;
		return super.onKeyDown(keyCode, event);
	}
	
	@Override
	public boolean dispatchTouchEvent(MotionEvent event) {
		int actionCode = event.getAction() & MotionEvent.ACTION_MASK;
		if(actionCode == MotionEvent.ACTION_DOWN) {
			HFButtonWidget.mPressButton = null;
	   	}
		return  super.dispatchTouchEvent(event);
	}
	//activityKeydown
	@Override
	public boolean onTouchEvent (MotionEvent event) {
		HPWidgetEventArgument eventArgs = getEventArgs();
		if(HPWidgetEvent.convertTouchEvent(event, eventArgs)) {
			if(onMessageProc(eventArgs))
				return true;
		}
		return  super.onTouchEvent(event);
	}
	/*=======================================================
	: ؼʼ
	:  
	ֵ: true:Ѵ  false: δ
	======================================================*/
	protected boolean onBeforeInit() {
		Configuration config = this.getResources().getConfiguration();
		HFOnChangeOrientationInterface listener = HFModesManager.getOnChangeOrientationListener();
		if(listener != null) {
		    int orientation = HFOrientation.eOrientation_Unknown;
		    orientation = parseOrientation(config.orientation);
			if(listener.OnChangeOrentation(this, orientation)) {
			  changeOrientation(orientation);
			}
		}
		return false;
	}   	
	/*=======================================================
	: ؼʼ
	:  
	ֵ: true:Ѵ  false: δ
	======================================================*/
	protected boolean onInit() {
		return false;
	}   
	/*======================================================
	: ģʽ뺯
	:  
	ֵ: true:Ѵ  false: δ
	======================================================*/
	protected boolean onReEnter() {
		return false;
	}
	/*======================================================
	: ģʽ¼
	: eventArgs [in] ¼
	ֵ: TRUE: ¼Ѵ FALSE: ¼δ
	======================================================*/
	protected boolean onMessageProc(HPWidgetEventArgument event) {
		if((event.eventType == HPWidgetEventType.eWidgetEventType_Key)
				&&(event.eventSubtype == HPWidgetKeyEvent.eWidgetKeyEvent_Up)) {
			HPWidgetKeyArgument keyEvent = event.getKeyEventArgs(); 
			 if(keyEvent.keyCode == KeyEvent.KEYCODE_BACK) {
				 HFModesManager.returnMode(getPendingTransition());
				 return true;
			 }
		}		
		return false;
	}    
	/*======================================================
	: ģʽĸº
	:  
	ֵ: true:Ѵ  false: δ
	======================================================*/
	protected boolean onUpdate() {
		return false;
	}
	/*======================================================
	: ģʽĹرպ
	:  
	ֵ: true:Ѵ  false: δ
	======================================================*/
	protected boolean onClose() {
		return false;
	}
	public HPWidgetEventArgument getEventArgs() {
		if(mEventArgs == null) {
			mEventArgs = new HPWidgetEventArgument();
		}
		return mEventArgs;
	}
	/*=======================================================
	: ȡؼλ
	: 
	ֵ:  ؼλ
	======================================================*/	
	public void getBound(HFWidgetBound bound) {
		if(bound != null) {
			bound.setLeft(0);
			bound.setTop(0);
			bound.setWidth(getWindowManager().getDefaultDisplay().getWidth());
			bound.setHeight(getWindowManager().getDefaultDisplay().getHeight());
		}
		return ;
	}	
	/*======================================================
	: װdrawable
	:  
	ֵ: 
	======================================================*/
	protected void reloadDrawable() {
		int index;
		HFLayerWidget layer = null;
		for(index = 0; index < mLayers.size(); index++) {
			layer = mLayers.get(index);
			if(layer != null) {
				layer.reloadDrawable();
			}
		}
	}
	/*======================================================
	: װͼؼ
	:  
	ֵ: 
	˵ıģʽеͼVisible֮øú
	======================================================*/
	@Override
	public void inflate() {
		if(!isOptimized())
			return ;
		HFLayerWidget layer = null;
		ArrayList<HFLayerWidget> layers = new ArrayList<HFLayerWidget>();
		for(int index = 0; index < mLayers.size(); ++index) {
			layer = mLayers.get(index);
			if(layer != null && !layer.isReady() && layer.getVisible()) {
				layers.add(layer);
			}
		}	
		if(layers.size() == 0)
			return ;
		
    	HFModeLoader modeLoader = getModeLoader();
        if(modeLoader == null) 
        	return ;

		for(int index = 0; index < layers.size(); ++index) {
			layers.get(index).loadWidgets(this, modeLoader);
		}
		closeModeLoader(modeLoader);
		modeLoader = null;
		layers = null;
	}	
	/*=======================================================
	:
	    Ϣ
	:
	    in_Handle:Ϣľ
	    ulMsg:Ϣ
	    ulParams1:1
	    ulParams2:2
		
	ֵ:
	    != 0 ɹ---bool
	=======================================================*/
	public int sendMessage(Object in_Handle, int msgId, Object params1, Object params2) {
		if(mWorkHandler != null) {
			Message msg = mWorkHandler.obtainMessage();
			msg.what = msgId;
			msg.obj = params1;
			mWorkHandler.removeMessages(msgId);
			mWorkHandler.sendMessage(msg);
		}
		return 0;
	}
	public int sendMessageDelayed(Object in_Handle, int msgId, Object params1, Object params2,long delayMillis) {
		if(mWorkHandler != null) {
			Message msg = mWorkHandler.obtainMessage();
			msg.what = msgId;
			msg.obj = params1;
			mWorkHandler.removeMessages(msgId);
			mWorkHandler.sendMessageDelayed(msg,delayMillis);
		}
		return 0;
	}
	public void sendMessage(int what, Object obj) {
		sendMessage(null, what, obj, null);
	}
	public void sendEmptyMessage(int what) {
		sendMessage(null, what, null, null);
	}
	public HFOnMessageInterface getOnMessageListener() {
		return mOnMessageListener;
	}
	public void setOnMessageListener(HFOnMessageInterface listener) {
		if(mWorkHandler == null) {
			mWorkHandler = new HFWorkHandler(this);
		}
		mOnMessageListener = listener;
	}
	public float getXScaleFactor() {
		return mXScaleFactor;
	}
	protected void setXScaleFactor(float mXScaleFactor) {
		this.mXScaleFactor = mXScaleFactor;
	}
	public float getYScaleFactor() {
		return mYScaleFactor;
	}
	protected void setYScaleFactor(float mYScaleFactor) {
		this.mYScaleFactor = mYScaleFactor;
	}
	/*=======================================================
	:
		
	:
		
	ֵ:
	=======================================================*/	
	protected void calcScaleFactor() {
		//X᷽
		mXScaleFactor = 1.0f;
		//Y᷽
		mYScaleFactor = 1.0f; 		
		if(HFModesManager.isScaleMode()) {
			float screenWidth = HFModesManager.getScreenWidth();
			float screenHeight = HFModesManager.getScreenHeight() - HFModesManager.getStatusBarHeight();
			float modeWidth = mModeData.getWidth();
			float modeHeight = mModeData.getHeight() - HFModesManager.getDesignBarHeight();
			if(screenWidth > 0 && screenHeight > 0) {
				mXScaleFactor = screenWidth/modeWidth;
				mYScaleFactor = screenHeight/modeHeight;
			}
		}
		int xFactor = (int)(mXScaleFactor * 100);
		int yFactor = (int)(mYScaleFactor * 100);
		mXScaleFactor = (xFactor == 0) ? 1.0f : mXScaleFactor;
		mYScaleFactor = (yFactor == 0) ? 1.0f : mYScaleFactor;
	}
	/*=======================================================
	:
		õźX
	:
		originX [in] ԭʼ
	ֵ:
		ź
	=======================================================*/	
	protected int getXScaleCoords(int originX) {
		double xx = originX;
		if(HFModesManager.isScaleMode()) {
			xx = xx * getXScaleFactor(); 
		}
		return (int) Math.ceil(xx);
	}
	/*=======================================================
	:
		õź
	:
		originX [in] ԭʼ
	ֵ:
		ź
	=======================================================*/	
	protected int getYScaleCoords(int originY) {
		double yy = originY;
		if(HFModesManager.isScaleMode()) {
			yy = yy * getYScaleFactor(); 
		}
		return (int) Math.ceil(yy);
	}	
	/*=======================================================
	:
		Կؼ
	:
		bound [in] ԭʼ
		deltaXY [in] ƫ
	ֵ:
	˵:
		ʱֻ꣬ſؼĿ
	=======================================================*/	
	public void scaleCoords(HFWidgetBound bound,int fixedshape) {
		if(bound != null && HFModesManager.isScaleMode()) {
			int w = getXScaleCoords(bound.getWidth());
			int h = getYScaleCoords(bound.getHeight());
			int l = getXScaleCoords(bound.getLeft());
			int t = getYScaleCoords(bound.getTop());
			if(fixedshape > 0){
				if(getXScaleFactor() > getYScaleFactor()){
					w = getYScaleCoords(bound.getWidth());
					l += (int) Math.ceil(bound.getWidth() * (mXScaleFactor - mYScaleFactor)) / 2;
				}else{
					h = getXScaleCoords(bound.getHeight());
					t += (int) Math.ceil(bound.getHeight() * (mYScaleFactor - mXScaleFactor)) /2;
				}
			}
			bound.setLeft(l);
			bound.setTop(t);
			bound.setWidth(w <= 0 ? 1:w);
			bound.setHeight(h <= 0 ? 1:h);
		}
	}
	/*=======================================================
	:
		Layerؼ
	:
		bound 		[in] ԭʼ
		out_DeltaXY	[out] źƫ
	ֵ:
	˵:
		ʱֻ꣬ſؼĿ
	=======================================================*/	
	protected void scaleLayerCoords(HFWidgetBound bound, HFWidgetPoint out_DeltaXY) {
		if(bound != null && HFModesManager.isScaleMode()) {
			int x0 = bound.getLeft();
			int y0 = bound.getTop();
			int x1 = getXScaleCoords(x0);
			int y1 = getYScaleCoords(y0);
			out_DeltaXY.X = x1 - x0;
			out_DeltaXY.Y = y1 - y0;
			bound.setLeft(x1);
			bound.setTop(y1);
		}
	}	
	/**
	* ȡǰģʽĶ
	*
	* @param  
	* @param  
	* @return 
	*/		
	public int getPendingTransition() {
		return mPendingTransition;
	}
	/**
	* õǰģʽĶ
	*
	* @param  defaultTransition [in] 
	* @param  
	* @return 
	*/		
	protected void setPendingTransition(int pendingTransition) {
		mPendingTransition = pendingTransition;
	}
	/**
	* ݵǰģʽconfigorientation
	*
	* @param  cfgOrientation [in] 
	* @param  
	* @return 
	*/			
	protected int parseOrientation(int cfgOrientation) {
		int orientation = HFOrientation.eOrientation_Unknown;
		switch(cfgOrientation) {
		case Configuration.ORIENTATION_LANDSCAPE: 
			orientation = HFOrientation.eOrientation_Landscape;
			break;
		case Configuration.ORIENTATION_PORTRAIT: 
			orientation = HFOrientation.eOrientation_Portrait;
			break;
		case Configuration.ORIENTATION_SQUARE: 
			orientation = HFOrientation.eOrientation_Square;
			break;
		}
		return orientation;
	}
	/**
	* ģʽл
	*
	* @param  newConfig [in] config
	* @param  
	* @return 
	*/		
	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
		HFOnChangeOrientationInterface listener = HFModesManager.getOnChangeOrientationListener();
		if(listener != null) {
			int orientation = parseOrientation(newConfig.orientation);
			if(listener.OnChangeOrentation(this, orientation)) {
				changeOrientation(orientation);
			}
		}
	}
	
	@Override
	public void onWindowFocusChanged(boolean hasFocus){
		super.onWindowFocusChanged(hasFocus);
		if(HFModesManager.getStatusBarHeight() == 0){
			Rect rect = new Rect();
			getWindow().getDecorView().getWindowVisibleDisplayFrame(rect);//ȡͼ,ע⣬Ҫñʽڱʽ֮󣬷
			if(HFModesManager.isFullScreen() == false)
			  HFModesManager.setStatusBarHeight(rect.top);
		}
	}
	/**
	* л
	*
	* @param  mOrientation 		[in] Ϣ
	* @param  
	* @return 
	*/		
	protected void changeOrientation(int orientation) {
    	HFModeLoader modeLoader = getModeLoader();
        if(	modeLoader == null 
        	|| orientation == getOrientation()) {
        	return ;
        }	
        //ú
        setOrientation(orientation);
        reloadLayout(modeLoader,true);
	}
	
	protected void reloadLayout(HFModeLoader modeLoader,boolean refreshList){
		if(modeLoader == null)
			modeLoader = getModeLoader();
		if(modeLoader == null)
			return;
		 HFLayerWidget pLayer = null;
		//бͼ
        ArrayList<HFLayerWidget> listLayers = new ArrayList<HFLayerWidget>();
    	//װģʽ
    	modeLoader.getModeData(mModeData);
    	//
    	calcScaleFactor();
    	//ȡͼܸ
    	int numLayers = modeLoader.getNumOfLayers();
    	if(refreshList){
    		//ȴбͼ
        	for(int i = 0; i < numLayers; i++) {
            	HFLayerStorage playerData = new HFLayerStorage();
        		if(0 == modeLoader.getLayerData(i, playerData)) {
        			if(playerData.getParent() > 0) {
    					scaleCoords(playerData.getBound(),0);
        				//бͼ㣬ݴ
        				pLayer = createLayerWidgets(modeLoader, playerData); 
        				if(pLayer != null) {
        					listLayers.add(pLayer);
        				}
        			}
        		}
        	}	
    	}
    	
    	//ٴбͼ
    	for(int i = 0; i < numLayers; i++) {
        	HFLayerStorage playerData = new HFLayerStorage();
    		if(0 == modeLoader.getLayerData(i, playerData)) {
    			if(playerData.getParent() <= 0) {
    				pLayer = findLayerByName(playerData.getName());
    				if(pLayer != null) {
        				scaleCoords(playerData.getBound(),0);
    					pLayer.changeOrientation(this, modeLoader, playerData, listLayers);
    				}
    			}		
    		}
    	}
    	//ݴбͼ
    	listLayers.clear();
    	listLayers = null;
    	//бͼ
    	closeModeLoader(modeLoader);
	}
	
	public void resetMapView(int width,int height){
		for(int i = 0; i < mLayers.size(); i++){
			HFLayerWidget layer = mLayers.get(i);
			if(autoResetMapviewSize) {
				for(int j = 0; j < layer.getNumOfWidgets();j++){
					HFBaseWidget widget = layer.getWidgetByIndex(j);
					if(widget instanceof HFMapWidget){
						if(widget.getBound() != null){
							widget.getBound().setWidth(width);
							widget.getBound().setHeight(height);
							widget.setBound(widget.getBound());
						}
						layer.reLayoutWidget(j);
					}
				}
				shouldResetMapviewSize = false;
			}else {
				shouldResetMapviewSize = true;
			}
			if(layer.getBound() != null){
				layer.getBound().setWidth(width);
				layer.getBound().setHeight(height);
			}
			layer.setBound(layer.getBound());
		}
	}
	
	/**
	 * ͼС
	 * @param ifChanged trueֻеһҪͼûõʱ򣬲ŻõͼС;falseõͼС
	 */
	public void resetMapView(boolean ifChanged) {
		if(ifChanged) {
			if(shouldResetMapviewSize)
				resetMapView(HFModesManager.getScreenWidth(),HFModesManager.getScreenHeight());
		}else {
			resetMapView(HFModesManager.getScreenWidth(),HFModesManager.getScreenHeight());
		}
	}
	
	public void beforeResetLayout(){
		
	}
	/*======================================================
	: ²
	:  
	
	ֵ: 
	======================================================*/
	public void reLayoutWidgets(int src_width,int src_height,int des_width,int des_height){
		//
    	double xScale = des_width*1.0/src_width;
    	double yScale = des_height*1.0/src_height;
		for(int i = 0; i < mLayers.size(); i++){
			HFLayerWidget layer = mLayers.get(i);
			HFModesManager.scaleCoords(layer.getBound(),xScale,yScale);
			for(int j = 0; j < layer.getNumOfWidgets();j++){
				HFBaseWidget widget = layer.getWidgetByIndex(j);
				HFModesManager.scaleCoords(widget.getBound(),xScale,yScale);
				layer.reLayoutWidget(j);
			}
			layer.setBound(layer.getBound());
		}
	}
	/**
	* ȡģʽ־
	*
	* @param  
	* @param  
	* @return ģʽ־
	*/		
	public int getOrientation() {
		return mOrientation;
	}
	/**
	* ģʽ־
	*
	* @param  orientation [in] ģʽ־
	* @param  
	* @return 
	*/		
	protected void setOrientation(int orientation) {
		mOrientation = orientation;
	}
	//Handler
	protected static class HFWorkHandler extends Handler {
		private Context mContext = null;
		public HFWorkHandler(Context context) {
			mContext = context;
		}
		@Override
		public void handleMessage(Message msg) {
			HFModeWidget mode = (HFModeWidget)mContext;
			if(mode != null) {
				HFOnMessageInterface listener = mode.getOnMessageListener();
				if(listener != null) {
					listener.OnHandleMessage(mContext, msg);
				}
			}
		}
	}
	public interface HFOnMessageInterface {
		public void OnHandleMessage(Context context, Message msg);
	} 
	/*======================================================
	: صָģʽ
	:    in_pcModeName      [in]  ģʽ
	ֵ:  ģʽ
	˵: ģʽջѴڣ 򽫸ģʽ֮ϵģʽջ
	======================================================*/
	public HFModeFragment returnToFragment(String modeName, int pendingTransition) {
		return null;
	}
	/*======================================================
	: صָģʽ
	:    in_pcModeName      [in]  ģʽ
	ֵ:  ģʽ
	˵: ģʽջѴڣ 򽫸ģʽ֮ϵģʽջ
	======================================================*/
	public HFModeWidget returnFragment(HFModeWidget mode, int pendingTransition) {
		return null;
	}	
	/*======================================================
	: صָģʽ
	:    in_pcModeName      [in]  ģʽ
	ֵ:  ģʽ
	˵: ģʽջѴڣ 򽫸ģʽ֮ϵģʽջ
	======================================================*/
	public HFModeWidget returnFragment(HFModeWidget mode, int pendingTransition,boolean isTag) {
		return null;
	}
	/*======================================================
	: صָģʽ
	:    modeName      [in]  ģʽ
	ֵ:  ģʽ
	˵: ģʽջѴڣ 򽫸ģʽ֮ϵģʽջ
	======================================================*/
	public HFModeFragment returnToFragment(String modeName, int pendingTransition,boolean isTag) {
		return null;
	}	
	/*======================================================
	: ñѡеRadioButton
	:  in_pRadioButton   [in] ѡеRadioButton
	ֵ: =0:ɹ>0 
	======================================================*/
	public Context getContext() {
		return this;
	}
	/*======================================================
	: ȡǰģʽ
	:    
	ֵ:  ǰģʽ
	======================================================*/
	public HFModeWidget getCurrentMode() {
		return this;
	}
	/*======================================================
	: ȡȫֻ
	:    
	ֵ:  ȫֻ
	======================================================*/
	public HPSysEnv getSysEnv() {
		return HPAppEnv.getSysEnv();
	}
	
	/*======================================================
	: ȡ˵
	:    
	ֵ:  ˵
	======================================================*/
	public HFSlideMenu getSlideMenu() {
		return mSlideMenu;
	}
	
	/*======================================================
	: жϵǰģʽǷmapViewؼ
	:    
	ֵ: truefalse:
	======================================================*/
	public boolean isModeContainMapView(){
		return false;
	}
	
	/*======================================================
	: ôڴСı
	:    
	ֵ: 
	======================================================*/
	protected void setWindowSizeChangeListener(){
		mWindowView = new View(getApplicationContext());
        WindowManager wm=(WindowManager)getApplicationContext().getSystemService("window");
        WindowManager.LayoutParams wmParams = new WindowManager.LayoutParams();
        wmParams.type=2002;   //ǹؼҲ2003
        wmParams.format=1;
        wmParams.flags=40;
        wmParams.width=30;
        wmParams.height=30;
        mWindowView.setBackgroundColor(Color.RED);
        wm.addView(mWindowView, wmParams);  //View
        mWindowView.getViewTreeObserver().addOnGlobalLayoutListener(new HFGlobalLayoutListener());
	}
	
	/*======================================================
	: ɾڴСı
	:    
	ֵ: 
	======================================================*/
	protected void moveWindowSizeChangeListener(){
		WindowManager wm=(WindowManager)getApplicationContext().getSystemService("window");
      	wm.removeView(mWindowView);
	}
	
	/*======================================================
	: 
	:  
	
	ֵ: 
	======================================================*/
	public View getRootView(){
		return mScrollView;
	}
	
	/*======================================================
	: ڴСıص
	:    
	ֵ: 
	======================================================*/
    public class HFGlobalLayoutListener implements OnGlobalLayoutListener{

		@Override
		public void onGlobalLayout() {
			// TODO Auto-generated method stub
			//try {
				//Thread.sleep(50);
				//int width = HFModeActivity.this.getWindowManager().getDefaultDisplay().getWidth();
				//int height = HFModeActivity.this.getWindowManager().getDefaultDisplay().getHeight();
			    //if(HFModesManager.getScreenWidth() != width || HFModesManager.getScreenHeight() != height){
			    //	 int src_width = HFModesManager.getScreenWidth();
				//	 int src_height = HFModesManager.getScreenHeight();
			    	// onSize(src_width,src_height,width,height);
			//		 HFModesManager.setScreenPixels(width, height);
			//		 HFModeWidget modeWidget = HFModesManager.getCurrentMode();
					// modeWidget.reLayoutWidgets(src_width,src_height,width,height);
				// }
			//} catch (InterruptedException e) {
				// TODO Auto-generated catch block
			//	e.printStackTrace();
			//}
		}
	}
    
    /*======================================================
	: ڴСı
	:  org_width:   ԭĿ
	       org_height:  ԭĸ
	       new_width:   Ŀ
	       new_height:  ĸ
	ֵ: 
	======================================================*/
    protected void onSize(int org_width,int org_height,int new_width,int new_height){
    	
    }
	public int getModeActivityState() {
		return mModeActivityState;
	}
	public void setModeActivityState(int mMapActivityState) {
		mModeActivityState = mMapActivityState;
	}
	public boolean isOptimized() {
		return mIsOptimized;
	}
	public void setIsOptimized(boolean mIsOptimized) {
		this.mIsOptimized = mIsOptimized;
	}
	
    private void initRequestArgs() {
    	Intent intent = getIntent();
  
    	//ӳʼлȡǷŻͼ㼰ؼ־
    	if(intent != null) {
    		setIsOptimized(intent.getBooleanExtra(HFModesManager.KEY_OPTIMIZED_CODE, false));
    	}    	
    }
	/*=======================================================
	: ͼ
	: λͼ
	ֵ:  
	======================================================*/	
	public Bitmap getScreenShot(Rect rect){
		 // ViewҪͼView
		mScrollView.setDrawingCacheEnabled(true);
		mScrollView.buildDrawingCache();
        Bitmap cache = mScrollView.getDrawingCache();
        Bitmap bitmap = null;
        if(rect == null){
           bitmap = Bitmap.createBitmap(cache, 0, 0, cache.getWidth(), cache.getHeight());
        }else{
           bitmap = Bitmap.createBitmap(cache, rect.left, rect.top, rect.width(), rect.height());
        }
        mScrollView.destroyDrawingCache();
    	mScrollView.setDrawingCacheEnabled(false);
		return bitmap;
	}
	
	/*======================================================
	: 
	:Ļ  
	
	ֵ: 
	======================================================*/
	public void setScreenOrientation(int requestedOrientation){
		int Orientation = ActivityInfo.SCREEN_ORIENTATION_UNSPECIFIED;
		if(requestedOrientation == HFOrientation.eOrientation_Portrait)
			Orientation = ActivityInfo.SCREEN_ORIENTATION_PORTRAIT;
		else if(requestedOrientation == HFOrientation.eOrientation_Landscape)
			Orientation = ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE;
		this.setRequestedOrientation(Orientation);
	}
	
	public boolean isExistFragment(String modeName){
		return false;
	}
	
	private void doAnalytics(int type){
		if(HFModesManager.getAnalyticsListener() == null)
			return;
		if(mAnalyticsStorage == null){
			mAnalyticsStorage = new HFAnalyticsStorage();
			mAnalyticsStorage.setCurrentTime(System.currentTimeMillis());
		}
			
		mAnalyticsStorage.setLifeCycle(type);
		mAnalyticsStorage.setModeName(getClass().getSimpleName());
		if(type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Create_Begin ||
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Start_Begin ||
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Resume_Begin ||
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Destroy_Begin || 
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_ReStart_Begin || 
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Pause_Begin || 
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Stop_Begin){
			mAnalyticsStorage.setCostTime(0);
		}else if(type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Create_Finish ||
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Start_Finish ||
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Resume_Finish ||
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Destroy_Finish || 
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_ReStart_Finish || 
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Pause_Finish || 
				type == HFAnalyticsStorage.HFModeLifeCycle.LifeCycle_Stop_Finish){
			mAnalyticsStorage.setCostTime(System.currentTimeMillis() - mAnalyticsStorage.getCurrentTime());
		}
		mAnalyticsStorage.setCurrentTime(System.currentTimeMillis());
		HFModesManager.getAnalyticsListener().onGetAnalyticsMsg(mAnalyticsStorage);
	}
	public byte isVeiledEffect() {
		if(mModeData != null)
			return mModeData.getB2VeiledEffect();
		return 0;
	}
	
	protected void checkLayoutOnResume() {
		if (Build.VERSION.SDK_INT >= 24
				&& (Build.MANUFACTURER.equalsIgnoreCase("OPPO"))) {
			HPWindowManager windowMan = new HPWindowManager(getContext());
			Display display = windowMan.getDefaultDisplay();
			DisplayMetrics realOutMetrics = new DisplayMetrics();
			display.getRealMetrics(realOutMetrics);
			int height = 0;
			int width = 0;
			height = display.getHeight();
			width = display.getWidth();
			if (height > 0 && width > 0) {
				if (getContext().getResources().getConfiguration().orientation == Configuration.ORIENTATION_PORTRAIT) {
					if(width != HFModesManager.getScreenWidth() || height != HFModesManager.getScreenHeight()){
						HFModesManager.setScreenPixels(width, height);
						beforeResetLayout();
						reloadLayout(null, false);
						resetMapView(width, height);
					}
				} else {
					if(height != HFModesManager.getScreenWidth() || width != HFModesManager.getScreenHeight()){
						HFModesManager.setScreenPixels(height, width);
						beforeResetLayout();
						reloadLayout(null, false);
						resetMapView(height, width);
					}
				}
				
			}
			
		}
	}
	
	/**
	 * ǷԶõͼСĵϰĻʱлⰴʱõͼСᵼµͼ
	 * @param auto
	 */
	public void setAutoRestMapviewSize(boolean auto) {
		autoResetMapviewSize = auto;
	}
}
