package cnv.hf.widgets;
/*********************************************************************************
FileName:cnv_hf_progresswidget.c
(C) Copyright 2000 by Careland
Description: 

	ʵֵprogressؼ
Note:  
Author:  gaoqs
Create Date: 2012-07-17
History:
	   [2012-07-17] Updated by  gaoqs. (ʵprogressؼ)
***********************************************************************************/
import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.ClipDrawable;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.GradientDrawable;
import android.graphics.drawable.LayerDrawable;
import android.view.Gravity;
import android.widget.ProgressBar;
import cnv.hf.widgets.HFDrawableWidget.HFDrawableEffect;
import cnv.hf.widgets.HFWidgetStorage.HFBaseStorage;
import cnv.hf.widgets.HFWidgetStorage.HFProgressItemStorage;
import cnv.hf.widgets.HFWidgetStorage.HFProgressStorage;

public class HFProgressWidget extends HFBaseWidget {
	
	//private int           maxProgress;    /*ֵ*/		
	private HFWidgetBound   progressBound;	/*Ļλ*/	
	private HFProgressItem  progressItem;	/*ֵ*/			
	private int             progressStyle;  /**/			
	
	public HFProgressWidget(Context context, Object widgetData) {
		super(context, widgetData);
		//
		progressItem = new HFProgressItem();
		//progressBound
		progressBound = new HFWidgetBound();
		//ʼ
		initProgressMembers(widgetData);
	}
	@Override
	protected void setHolder(Context context,Object widgetData) {
		setObject(new ProgressBar(context, null, android.R.attr.progressBarStyleHorizontal));
	}
	private void initProgressMembers(Object widgetData) {
		HFProgressStorage pData = (HFProgressStorage)widgetData;
		if(pData != null) {
			//ýƵķΧ
			setProgressBound(pData.getPogressBound());
			//ýķ
			setProgressStyle(pData.getProgressStyle());
			//ý
			setProgressItem(pData.getProgressItem());
			//ýɫֵ
			setLayerDrawable();			
		}
	}
	/*======================================================
	: ý
	:  
	ֵ: 
	======================================================*/	
	private void setProgressItem(HFProgressItemStorage progressItemStorage) {
		if(progressItemStorage != null) {
			
			setStartDrawable(convertDrawable(progressItemStorage.getStartDrawable()));
			setEndDrawable(convertDrawable(progressItemStorage.getEndDrawable()));
			setCenterDrawable(convertDrawable(progressItemStorage.getCenterDrawable()));
		}
	}
	/*======================================================
	: ȡֵ
	:  
	ֵ: ֵ
	======================================================*/
	public int getMaxProgress() {
		
		ProgressBar progressBar = ((ProgressBar)getObject());
		if(progressBar != null) {
			return progressBar.getMax();
		}
		return 0;
	}
	/*======================================================
	: ýֵ
	:  maxProgress    [in] ֵ
	ֵ: 
	======================================================*/
	public void setMaxProgress(int maxProgress) {
		ProgressBar progressBar = ((ProgressBar)getObject());
		if(progressBar != null) {
			progressBar.setMax(maxProgress);
		}
	}
	/*======================================================
	: ȡλ
	:  
	ֵ: λ
	======================================================*/
	public HFWidgetBound getProgressBound() {
		return progressBound;
	}
	/*======================================================
	: ýλ
	:  pogressBound  [in] Ƶλ
	ֵ: 
	======================================================*/
	public void setProgressBound(HFWidgetBound bound) {
		progressBound.setBound(bound);
	}
	/*======================================================
	: ȡ
	:  
	ֵ: ķ
	======================================================*/
	public int getProgressStyle() {
		return progressStyle;
	}
	/*======================================================
	: ý
	:  style     [in] ȷ
	ֵ: 
	======================================================*/
	public void setProgressStyle(int style) {
		this.progressStyle = style;
	}
	/*======================================================
	: ȡʼֵɫͼƬ
	: 
	ֵ: ɫͼƬ
	======================================================*/
	public HFDrawableWidget getStartDrawable() {
		if(progressItem != null) {
			return progressItem.getStartDrawable();
		}
		return null;
	}
	/*======================================================
	: ýʼֵɫͼƬ
	:  drawable  [in] ɫͼƬId
	ֵ: 
	======================================================*/		
	public void setStartDrawable(HFDrawableWidget drawable) {
		if(progressItem != null) {
			progressItem.setStartDrawable(drawable);
			//ýɫֵ
			//setLayerDrawable();
		}
	}
	/*======================================================
	: ȡֵɫͼƬ
	: 
	ֵ: ɫͼƬ
	======================================================*/	
	public HFDrawableWidget getEndDrawable() {
		if(progressItem != null) {
			return progressItem.getEndDrawable();
		}
		return null;
	}
	/*======================================================
	: ýֵɫͼƬ
	:  drawable  [in] ɫͼƬId
	ֵ: 
	======================================================*/			
	public void setEndDrawable(HFDrawableWidget drawable) {
		if(progressItem != null) {
			progressItem.setEndDrawable(drawable);
			//ýɫֵ
			//setLayerDrawable();
		}
	}
	/*======================================================
	: ȡм䲿ֵɫͼƬ
	: 
	ֵ: ɫͼƬ
	======================================================*/		
	public HFDrawableWidget getCenterDrawable() {
		if(progressItem != null) {
			return progressItem.getCenterDrawable();
		}
		return null;
	}
	/*======================================================
	: ýм䲿ֵɫͼƬ
	:  drawable  [in] ɫͼƬId
	ֵ: 
	======================================================*/			
	public void setCenterDrawable(HFDrawableWidget drawable) {
		if(progressItem != null) {
			progressItem.setCenterDrawable(drawable);
			//ýɫֵ
			//setLayerDrawable();
		}
	}
	/*======================================================
	: ȡǰֵ
	:  
	ֵ: ֵ
	======================================================*/
	public int getProgress() {
		ProgressBar progressBar = ((ProgressBar)getObject());
		if(progressBar != null) {
			return progressBar.getProgress();
		}
		return 0;
	}
	/*======================================================
	: ýǰֵ
	: progress    [in] ֵ
	ֵ: 
	======================================================*/
	public void setProgress(int progress) {
		ProgressBar progressBar = ((ProgressBar)getObject());
		if(progressBar != null) {
			progressBar.setProgress(progress);
		}
	}
	/*======================================================
	: ʵֿؼĺл
	: 	widgetData  [in] ؼ
	ֵ: =0: лɹ; >0: 
	======================================================*/
    @Override
	protected int changeOrientation(HFBaseStorage widgetData) {
    	super.changeOrientation(widgetData);
    	HFProgressStorage pData = (HFProgressStorage)widgetData;
		if(pData != null) {
			//ýƵķΧ
			setProgressBound(pData.getPogressBound());
			//ýķ
			setProgressStyle(pData.getProgressStyle());
			//ý
			setProgressItem(pData.getProgressItem());
			//ýɫֵ
			setLayerDrawable();	
		}
		return 0;
	}	
	/*======================================================
	: ʵֿؼĺл
	: 	widget  [in] ؼ
	ֵ: =0: лɹ; >0: 
	======================================================*/
    @Override
	protected int changeOrientation(HFBaseWidget widget) {
    	super.changeOrientation(widget);
    	HFProgressWidget pBase = (HFProgressWidget) widget;
		if(pBase != null) {
			setProgressBound(pBase.getProgressBound());
		}
		return 0;
	}	    
	/*======================================================
	: ȡǰıɫ
	: 
	ֵ: ɫ
	======================================================*/
	private int [] getBackgroundColors() {
		
		int colors[] = new int []{	Color.parseColor("#ff9d9e9d"), 
									Color.parseColor("#ff5a5d5a"), 
									Color.parseColor("#ff747674")};
		
		HFDrawableWidget drawable = getDefaultDrawable();
		if(drawable != null) {
			if((drawable.getEffect() & HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Color) {
				for(int index = 0; index < colors.length; index++) {
					colors[index] = (int)drawable.getColor();//convert2ARGB((int)drawable.getColor());
				}
			}
		}

		return colors;
	}
	
	/*======================================================
	: ȡǰɫ
	: 
	ֵ: ɫ
	======================================================*/
	private int [] getProgressColors() {
		
		int colors[] = new int []{	Color.parseColor("#80ff0000"), 
									Color.parseColor("#8000ff00"), 
									Color.parseColor("#ff747674")};
		
		HFDrawableWidget startDrawable = getStartDrawable();
		HFDrawableWidget centerDrawable = getCenterDrawable();
		HFDrawableWidget endDrawable = getEndDrawable();
		
		if((startDrawable != null && centerDrawable != null && endDrawable != null)
			&&((startDrawable.getEffect() & HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Color)
			&&((centerDrawable.getEffect() & HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Color)
			&&((endDrawable.getEffect() & HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Color)) {

				colors[0] = (int)startDrawable.getColor();//convert2ARGB((int)startDrawable.getColor());
				colors[1] = (int)centerDrawable.getColor();//convert2ARGB((int)centerDrawable.getColor());
				colors[2] = (int)endDrawable.getColor();//convert2ARGB((int)endDrawable.getColor());
		}

		return colors;
	}	
	/*======================================================
	: ýֵ
	: 
	ֵ: 
	======================================================*/
	private void setLayerDrawable() {
		
		LayerDrawable progressDrawable = (LayerDrawable)((ProgressBar)getObject()).getProgressDrawable();
		Drawable[] outDrawables = new Drawable[progressDrawable.getNumberOfLayers()];
		float radiu = getBound().getHeight()/2;
		((ProgressBar)getObject()).setBackgroundDrawable(null);
		for (int i = 0; i < progressDrawable.getNumberOfLayers(); i++) {

				switch (progressDrawable.getId(i)) {
		
				case android.R.id.background: {//ý 
					//outDrawables[i] = progressDrawable.getDrawable(i);
					GradientDrawable mDrawable = new GradientDrawable(GradientDrawable.Orientation.TOP_BOTTOM,
							getBackgroundColors());
					
					mDrawable.setGradientCenter(0.0f, 0.75f);
					mDrawable.setGradientRadius((float)(Math.sqrt(5) * 60)); 
					mDrawable.setGradientType(GradientDrawable.LINEAR_GRADIENT);
					mDrawable.setCornerRadii(new float[] { radiu, radiu, radiu, radiu, radiu, radiu, radiu, radiu }); 
					outDrawables[i] = mDrawable;
				}
				break;
		
				case android.R.id.secondaryProgress://ö
				{
				   //ԭעͣ6-12޸ڱһ
				   // outDrawables[i] = progressDrawable.getDrawable(i);
					GradientDrawable mDrawable = new GradientDrawable(GradientDrawable.Orientation.TOP_BOTTOM,
							getBackgroundColors());
					
					mDrawable.setGradientCenter(0.0f, 0.75f);
					mDrawable.setGradientRadius((float)(Math.sqrt(5) * 60)); 
					mDrawable.setGradientType(GradientDrawable.LINEAR_GRADIENT);
					mDrawable.setCornerRadii(new float[] { radiu, radiu, radiu, radiu, radiu, radiu, radiu, radiu }); 
					outDrawables[i] = mDrawable;
				}
				break;
		
				case android.R.id.progress: {//ý
					GradientDrawable mDrawable = new GradientDrawable(GradientDrawable.Orientation.TOP_BOTTOM,
													getProgressColors());
			
					mDrawable.setGradientCenter(0.0f, 0.75f);
					mDrawable.setGradientRadius((float)(Math.sqrt(5) * 60)); 
					mDrawable.setGradientType(GradientDrawable.LINEAR_GRADIENT);
					mDrawable.setCornerRadii(new float[] { radiu, radiu, radiu, radiu, radiu, radiu, radiu, radiu });   
					Drawable oldDrawable = progressDrawable.getDrawable(i);
			        ClipDrawable proDrawable = new ClipDrawable(mDrawable, Gravity.LEFT,ClipDrawable.HORIZONTAL);
			        proDrawable.setLevel(oldDrawable.getLevel());
			        outDrawables[i] = proDrawable;
				}
				break;
				default:
				break;
			}
		}
//		progressDrawable = new LayerDrawable(outDrawables);
		LayerDrawable newDrawable = new LayerDrawable(outDrawables);
		for (int i = 0; i < progressDrawable.getNumberOfLayers(); i++){
			newDrawable.setId(i, progressDrawable.getId(i));
		}
		((ProgressBar)getObject()).setProgressDrawable(newDrawable);
	}
	
	//
	public class ProgressStyle {
	
	    public final static int eProgressStyle_Horiz   = 0x00000001;   //ˮƽ
	    public final static int eProgressStyle_Spinner = 0x00000002;   //Բν,Բֻandroidʹ
	} 
	//
	public class HFProgressItem {
		private HFDrawableWidget  startDrawable;   /*ͼƬɫ*/		
		private HFDrawableWidget  endDrawable;		/*ͼƬɫ*/		
		private HFDrawableWidget  centerDrawable;	/*ͼƬɫ*/		
		//private int				 		   progress;	/*ǰֵ*/
		/*======================================================
		: ȡʼֵɫͼƬ
		: 
		ֵ: ɫͼƬ
		======================================================*/
		public HFDrawableWidget getStartDrawable() {
			return startDrawable;
		}
		/*======================================================
		: ýʼֵɫͼƬ
		:  drawable  [in] ɫͼƬId
		ֵ: 
		======================================================*/		
		public void setStartDrawable(HFDrawableWidget drawable) {
			this.startDrawable = drawable;
		}
		/*======================================================
		: ȡֵɫͼƬ
		: 
		ֵ: ɫͼƬ
		======================================================*/	
		public HFDrawableWidget getEndDrawable() {
			return endDrawable;
		}
		/*======================================================
		: ýֵɫͼƬ
		:  drawable  [in] ɫͼƬId
		ֵ: 
		======================================================*/			
		public void setEndDrawable(HFDrawableWidget drawable) {
			this.endDrawable = drawable;
		}
		/*======================================================
		: ȡм䲿ֵɫͼƬ
		: 
		ֵ: ɫͼƬ
		======================================================*/		
		public HFDrawableWidget getCenterDrawable() {
			return centerDrawable;
		}
		/*======================================================
		: ýм䲿ֵɫͼƬ
		:  drawable  [in] ɫͼƬId
		ֵ: 
		======================================================*/			
		public void setCenterDrawable(HFDrawableWidget drawable) {
			this.centerDrawable = drawable;
		}
	} 

}
