package cnv.hf.widgets;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.StateListDrawable;
import android.view.ViewParent;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import cnv.hf.widgets.HFWidgetStorage.HFBaseStorage;
import cnv.hf.widgets.HFWidgetStorage.HFSwitchStorage;

public class HFSwitchWidget extends HFButtonWidget{
	
	private HFWidgetBound		switchBound;				/*switchͼƬλ*/				
	private HFDrawableWidget	switchOnDefaultDrawable;	/*On״̬ͼƬɫϢ*/		
	private HFDrawableWidget	switchOnFocusDrawable;		/*On״̬ͼƬɫϢ*/		
	private HFDrawableWidget	switchOnClickDrawable;		/*On״̬ͼƬɫϢ*/		
	private HFDrawableWidget	switchOnDisableDrawable;	/*On״̬ͼƬɫϢ*/		
	private HFDrawableWidget	switchOffDefaultDrawable;	/*Off״̬ͼƬɫϢ*/		
	private HFDrawableWidget	switchOffFocusDrawable;		/*Off״̬ͼƬɫϢ*/		
	private HFDrawableWidget	switchOffClickDrawable;		/*Off״̬ͼƬɫϢ*/		
	private HFDrawableWidget	switchOffDisableDrawable;	/*Off״̬ͼƬɫϢ*/	
	private HFOnWidgetCheckedChangeInterface mOnCheckedChangeListener = null;

	public HFSwitchWidget(Context context, Object widgetData) {
		super(context, widgetData);
		//ʼ
		initSwitchMembers(widgetData);
		//ػؼChanged¼
		((CompoundButton)getObject()).setOnCheckedChangeListener(new OnSwitchCheckedChangeListener());
	}
	/*======================================================
	: ʼؼԱ
	: widgetData [in] ؼ
	ֵ: ؼ
	======================================================*/
	private void initSwitchMembers(Object widgetData) {

		HFSwitchStorage data = (HFSwitchStorage)widgetData;
		CompoundButton switchButton = ((CompoundButton)getObject());	
		if(data != null && switchButton != null) {
			setSwitchBound(data.getSwitchBound());
			setSwitchOnDefaultDrawable(convertDynamicDrawable(data.getSwitchOnDefaultDrawable(), true,data.getSwitchBound()));
			setSwitchOnClickDrawable(convertDynamicDrawable(data.getSwitchOnClickDrawable(), true,data.getSwitchBound(),data.getSwitchOnDefaultDrawable().getBitmap(),0));
			setSwitchOnFocusDrawable(convertDynamicDrawable(data.getSwitchOnFocusDrawable(), true,data.getSwitchBound()));
			setSwitchOnDisableDrawable(convertDynamicDrawable(data.getSwitchOnDisableDrawable(), true,data.getSwitchBound()));
			setSwitchOffDefaultDrawable(convertDynamicDrawable(data.getSwitchOffDefaultDrawable(), true,data.getSwitchBound()));
			setSwitchOffClickDrawable(convertDynamicDrawable(data.getSwitchOffClickDrawable(), true,data.getSwitchBound(),data.getSwitchOffDefaultDrawable().getBitmap(),0));
			setSwitchOffFocusDrawable(convertDynamicDrawable(data.getSwitchOffFocusDrawable(), true,data.getSwitchBound()));
			setSwitchOffDisableDrawable(convertDynamicDrawable(data.getSwitchOffDisableDrawable(), true,data.getSwitchBound()));	
		}
	}
	public HFWidgetBound getSwitchBound() {
		return switchBound;
	}
	
//	private void setDrawableBound(Drawable drawable, HFWidgetBound bound) {
//		
//		if(drawable != null && bound != null) {
//			drawable.setBounds(	bound.getLeft(), 
//								bound.getTop(), 
//								bound.getLeft() + bound.getWidth() -1, 
//								bound.getTop() + bound.getHeight() -1);
//		}
//	}
	public void setSwitchBound(HFWidgetBound switchBound) {
		
		this.switchBound = switchBound;
		
//		setDrawableBound(switchOnDefaultDrawable.getBitmap(), 	switchBound);
//		setDrawableBound(switchOnFocusDrawable.getBitmap(), 	switchBound);
//		setDrawableBound(switchOnClickDrawable.getBitmap(), 	switchBound);
//		setDrawableBound(switchOnDisableDrawable.getBitmap(), 	switchBound);
//		setDrawableBound(switchOffDefaultDrawable.getBitmap(), 	switchBound);
//		setDrawableBound(switchOffFocusDrawable.getBitmap(), 	switchBound);
//		setDrawableBound(switchOffClickDrawable.getBitmap(), 	switchBound);
//		setDrawableBound(switchOffDisableDrawable.getBitmap(), 	switchBound);
	}
	/*=======================================================
	: ȡؼλ
	: 
	ֵ:  ؼλ
	======================================================*/	
	@Override
	public HFWidgetBound getBound() {
	
		HFWidgetBound result = super.getBound();
		return result;
	}
	/*======================================================
	: ȡؼ״̬ͼƬɫ(SwitchOn)
	:  
	ֵ: ͼƬɫ
	======================================================*/
	public HFDrawableWidget getSwitchOnDefaultDrawable() {
		return switchOnDefaultDrawable;
	}
	/*======================================================
	: ÿؼ״̬ͼƬɫ(SwitchOn)
	:  drawable    [in] ͼƬɫ
	ֵ: 
	======================================================*/
	public void setSwitchOnDefaultDrawable(HFDrawableWidget drawable) {
		this.switchOnDefaultDrawable = drawable;
		setButtonDrawable();
	}
	/*======================================================
	: ȡؼĽ״̬ͼƬɫ(SwitchOn)
	:  
	ֵ: ͼƬɫ
	======================================================*/
	public HFDrawableWidget getSwitchOnFocusDrawable() {
		return switchOnFocusDrawable;
	}
	/*======================================================
	: ȡؼĽ״̬ͼƬɫ(SwitchOn)
	:  
	ֵ: ͼƬɫ
	======================================================*/
	public void setSwitchOnFocusDrawable(HFDrawableWidget drawable) {
		this.switchOnFocusDrawable = drawable;
		setButtonDrawable();
	}
	/*======================================================
	: ȡؼĵ״̬ͼƬɫ(SwitchOn)
	:  
	ֵ: ͼƬɫ
	======================================================*/
	public HFDrawableWidget getSwitchOnClickDrawable() {
		return switchOnClickDrawable;
	}
	/*======================================================
	: ÿؼĵ״̬ͼƬɫ(SwitchOn)
	:  drawable    [in] ͼƬɫ
	ֵ: 
	======================================================*/
	public void setSwitchOnClickDrawable(HFDrawableWidget switchOnClickDrawable) {
		this.switchOnClickDrawable = switchOnClickDrawable;
		setButtonDrawable();
	}
	/*======================================================
	: ȡؼĽֹ״̬ͼƬɫ(SwitchOn)
	:  
	ֵ: ͼƬɫ
	======================================================*/
	public HFDrawableWidget getSwitchOnDisableDrawable() {
		return switchOnDisableDrawable;
	}
	/*======================================================
	: ÿؼĽֹ״̬ͼƬɫ(SwitchOn)
	:  drawable    [in] ͼƬɫ
	ֵ: 
	======================================================*/
	public void setSwitchOnDisableDrawable(HFDrawableWidget switchOnDisableDrawable) {
		this.switchOnDisableDrawable = switchOnDisableDrawable;
		setButtonDrawable();
	}
	/*======================================================
	: ȡؼ״̬ͼƬɫ(SwitchOff)
	:  
	ֵ: ͼƬɫ
	======================================================*/
	public HFDrawableWidget getSwitchOffDefaultDrawable() {
		return switchOffDefaultDrawable;
	}
	/*======================================================
	: ÿؼ״̬ͼƬɫ(SwitchOff)
	:  drawable    [in] ͼƬɫ
	ֵ: 
	======================================================*/
	public void setSwitchOffDefaultDrawable(HFDrawableWidget switchOffDefaultDrawable) {
		this.switchOffDefaultDrawable = switchOffDefaultDrawable;
		setButtonDrawable();
	}
	/*======================================================
	: ȡؼĽ״̬ͼƬɫ(SwitchOff)
	:  
	ֵ: ͼƬɫ
	======================================================*/
	public HFDrawableWidget getSwitchOffFocusDrawable() {
		return switchOffFocusDrawable;
	}
	/*======================================================
	: ÿؼĽ״̬ͼƬɫ(SwitchOff)
	:  drawable    [in] ͼƬɫ
	ֵ: 
	======================================================*/
	public void setSwitchOffFocusDrawable(HFDrawableWidget switchOffFocusDrawable) {
		this.switchOffFocusDrawable = switchOffFocusDrawable;
		setButtonDrawable();
	}
	/*======================================================
	: ȡؼĵ״̬ͼƬɫ(SwitchOff)
	:  
	ֵ: ͼƬɫ
	======================================================*/
	public HFDrawableWidget getSwitchOffClickDrawable() {
		return switchOffClickDrawable;
	}
	/*======================================================
	: ÿؼĵ״̬ͼƬɫ(SwitchOff)
	:  drawable    [in] ͼƬɫ
	ֵ: 
	======================================================*/
	public void setSwitchOffClickDrawable(HFDrawableWidget switchOffClickDrawable) {
		this.switchOffClickDrawable = switchOffClickDrawable;
		setButtonDrawable();
	}
	/*======================================================
	: ȡؼĽ ֹ״̬ͼƬɫ(SwitchOff)
	:  
	ֵ: ͼƬɫ
	======================================================*/
	public HFDrawableWidget getSwitchOffDisableDrawable() {
		return switchOffDisableDrawable;
	}
	/*======================================================
	: ÿؼĽֹ״̬ͼƬɫ(SwitchOff)
	:  drawable    [in] ͼƬɫ
	ֵ: 
	======================================================*/
	public void setSwitchOffDisableDrawable(HFDrawableWidget switchOffDisableDrawable) {
		this.switchOffDisableDrawable = switchOffDisableDrawable;
		setButtonDrawable();
	}
	/*======================================================
	: ȡSwitchǷѡ
	: 
	ֵ: Ƿѡб־
	======================================================*/
	public boolean getChecked() {
		
		CompoundButton switchButton = ((CompoundButton)getObject());
		if(switchButton != null) {
			return switchButton.isChecked();
		}
		return false;
	}
	/*======================================================
	: SwitchǷѡ
	:  in_bChecked      [in] Ƿѡ
	ֵ: 
	======================================================*/
	public void setChecked(boolean checked) {
		
		CompoundButton switchButton = ((CompoundButton)getObject());
		if(switchButton != null) {
			switchButton.setChecked(checked);
			switchButton.invalidate();
		}
	}
	/*======================================================
	: ʵֿؼĺл
	: 	widgetData  [in] ؼ
	ֵ: =0: лɹ; >0: 
	======================================================*/
    @Override
	protected int changeOrientation(HFBaseStorage widgetData) {
    	super.changeOrientation(widgetData);
    	HFSwitchStorage pData = (HFSwitchStorage)widgetData;
		if(pData != null) {
			setSwitchBound(pData.getSwitchBound());
		}
		return 0;
	}
	/*======================================================
	: ʵֿؼĺл
	: 	widget  [in] ؼ
	ֵ: =0: лɹ; >0: 
	======================================================*/
    @Override
	protected int changeOrientation(HFBaseWidget widget) {
    	super.changeOrientation(widget);
    	HFSwitchWidget pBase = (HFSwitchWidget) widget;
		if(pBase != null) {
			setSwitchBound(pBase.getSwitchBound());
		}
		return 0;
	}	    
	/*======================================================
	: ȡఴť״̬ͼƬ
	:  
	ֵ: ť״̬ͼƬ
	======================================================*/
	public  StateListDrawable getButtonListDrawable() {
		
		StateListDrawable sd = null;
		
		Drawable sondNormal =  getDrawable(getSwitchOnDefaultDrawable());
		Drawable sondClick  =  getDrawable(getSwitchOnClickDrawable());
		Drawable sondFocus  =  getDrawable(getSwitchOnFocusDrawable());
		Drawable sondDisable = getDrawable(getSwitchOnDisableDrawable());	 
		
		Drawable soffdNormal =  getDrawable(getSwitchOffDefaultDrawable());
		Drawable soffdClick  =  getDrawable(getSwitchOffClickDrawable());
		Drawable soffdFocus  =  getDrawable(getSwitchOffFocusDrawable());
		Drawable soffdDisable = getDrawable(getSwitchOffDisableDrawable());	
		
		if((sondNormal != null && sondClick != null && sondFocus != null )
			&&(soffdNormal != null && soffdClick != null && soffdFocus != null )) {
			
			sd = new StateListDrawable(); 
			sd.addState(new int[]{android.R.attr.state_focused, android.R.attr.state_checked}, sondFocus);  
			sd.addState(new int[]{android.R.attr.state_pressed, android.R.attr.state_checked}, sondClick);  
			if(getSwitchOnDisableDrawable() != null) {
				sd.addState(new int[]{-android.R.attr.state_enabled, android.R.attr.state_checked}, sondDisable);
			}
			sd.addState(new int[]{android.R.attr.state_enabled, android.R.attr.state_checked}, sondNormal);
			
			sd.addState(new int[]{android.R.attr.state_focused, -android.R.attr.state_checked}, soffdFocus);  
			sd.addState(new int[]{android.R.attr.state_pressed, -android.R.attr.state_checked}, soffdClick);  
			if(getSwitchOffDisableDrawable() != null) {
				sd.addState(new int[]{-android.R.attr.state_enabled, -android.R.attr.state_checked}, soffdDisable);
			}
			sd.addState(new int[]{android.R.attr.state_enabled, -android.R.attr.state_checked}, soffdNormal);  
			
		}
    	return sd;	
	}
	/*======================================================
	: ðť״̬ͼƬ
	:   btnStatus [in] ť״̬
	        drawable  [in] ͼƬ
	ֵ: ť״̬ͼƬ
	======================================================*/
    private void setButtonDrawable() {
    	
    	StateListDrawable sd = getButtonListDrawable();
		CompoundButton switchButton = ((CompoundButton)getObject());
		if(switchButton != null && sd != null) {
//			HFWidgetBound bound = getSwitchBound();
//			if(bound != null) {
//				int right = bound.getLeft() + bound.getWidth() - 1;
//				int bottom = bound.getTop() + bound.getHeight() - 1;
//				sd.setBounds(bound.getLeft(), bound.getTop(), right, bottom);
//			}
			switchButton.setButtonDrawable(sd);
		}
		return ;
    } 
	/*======================================================
	: ȡؼlistener
	:  
	ֵ: listenerָ
	======================================================*/
	public HFOnWidgetCheckedChangeInterface getOnCheckedChangeListener() {
		return mOnCheckedChangeListener;
	}
	/*======================================================
	: ÿؼlistener
	:  listener  [in] listener
	ֵ: 
	======================================================*/	
	public void setOnCheckedChangeListener(HFOnWidgetCheckedChangeInterface listener) {
		this.mOnCheckedChangeListener = listener;
	}
	/*======================================================
	:  switchؼı¼Ӧ
	:  buttonView   [in]  ؼ
	       isChecked    [in]  ѡб־
	ֵ:
	======================================================*/
	public interface HFOnWidgetCheckedChangeInterface {
		public void onCheckedChanged(HFBaseWidget buttonView, boolean isChecked);
	}
	
	//ػViewؼ¼ɷԶؼ
	private class OnSwitchCheckedChangeListener implements OnCheckedChangeListener {

		@Override
		public void onCheckedChanged(CompoundButton buttonView,
				boolean isChecked) {
			ViewParent layer = buttonView.getParent();
			if((layer != null) && (layer instanceof HFLayerWidget)) {
				HFBaseWidget widget = ((HFLayerWidget)layer).findWidgetByObject(buttonView);
				if(widget != null && mOnCheckedChangeListener != null) {
					mOnCheckedChangeListener.onCheckedChanged(widget, isChecked);
				}
			}
			buttonView.invalidate();
		}
	}
	
	/*======================================================
	: ȡť״̬ͼƬ
	:  
	ֵ: ť״̬ͼƬ
	======================================================*/
	public  StateListDrawable getBackGroundListDrawable() {
		
		StateListDrawable sd = null;		
		Drawable normald = getDrawable(getDefaultDrawable());
		Drawable focusd = getDrawable(getFocusDrawable());
		Drawable clickd = getDrawable(getClickDrawable());
		Drawable disabled = getDrawable(getDisableDrawable());
		
		if(!(normald == null || focusd == null || clickd == null )) {
			sd = new StateListDrawable();   
			sd.addState(new int[]{android.R.attr.state_focused}, focusd);  
			sd.addState(new int[]{android.R.attr.state_pressed}, clickd);  
			
			if(disabled != null) {
				sd.addState(new int[]{-android.R.attr.state_enabled}, disabled);
			}
			sd.addState(new int[]{android.R.attr.state_enabled}, normald);  
		}
    	return sd;	
	}
}
